	org $1001-2
	dw  $1001
	
	include "music/!playerv.asm"
	
	dw nextln,0	; second word is line number
	db $9E,"4109",0
nextln	db 0,0

plasma = $C0		; up to 16 bytes

temp_ptr = $D4		; 8 bytes!

sprite_pos_ptr = $DC	; 2 bytes
sprite_mask_ptr = $DE	; 2 bytes
sprite_gfx_ptr = $E0	; 2 bytes
sprite_data_ptr = $E2	; 2 bytes
letter_index = $E4	; 1 byte
flash_data_ptr = $E6	; 2 bytes

star_screen_ptr = $DC
star_src_ptr = $DE
star_index = $E4	; 1 byte

NO_RESTORE_FLAG = $C6 ; this is an arbitrary number, which does not occur in the bitmap, to flag that the sprite has not been saved

ras	macro v1, v2, v2
	lda #v1
	ldx #v2
	sta $FF14
	stx $FF06
	jsr waste_33
	endm
	
start
	sta $FF3E
	cli
	;
	ldx #$0F			; reset basic colors
cp1	lda $E143,x
	sta $0113,x
	dex
	bpl cp1
	;
	; ---
	;
	ldx #$FE			; sync value for PAL
	lda $FF07
	and #$40
	beq sync01
	ldx #$F7			; sync for NTSC 
sync01	cpx $FF1D
	bcs sync01
	;
	lda #$0B			; screen off
	sta $FF06
	lda #$41			; border gray
	sta $FF19
	;
	sei
	sta $ff3f
	;
	ldx #$02
il0	lda $00,x			; save zero-page variables
	sta $FC00,x
	inx
	bne il0
	;
	; ---------------------------
	; main init
	;
	ldy #$00
	sty temp_ptr
	sty temp_ptr+2
	lda #$48			; target ($4800)
	sta temp_ptr+3
	;
il2	lda #$40			; sourcr ($4000)
	sta temp_ptr+1
	;   
	ldx #$07
	;
il1	lda (temp_ptr),y		; copy color/lum map 3 times
il3	sta (temp_ptr+2),y
	iny
	bne il1
	;
	inc temp_ptr+1
	inc temp_ptr+3
	;
	dex
	bpl il1
	;
	lda temp_ptr+3
	cmp #$60
	bne il2
	;
	jsr PLAYER_FREQ_INIT
	;
	jsr timeline_reset
	;
	lda #NO_RESTORE_FLAG
	sta sprite_saved
	;
	lda #$00
	sta letter_index
	sta star_index
	;
	lda #sprite_pos_data & 255
	sta sprite_data_ptr
	lda #sprite_pos_data >> 8
	sta sprite_data_ptr+1
	;
	jsr set_irq1
	;
	jsr flash_data_reset
	;
	lda $FF07
	and #$40
	beq pal_1
	;
	lda #$60
	sta ntsc_1
pal_1	;
	;
	; --------------------------
	;
	lda #$CC
	cmp $FF1D
	bne *-3
	;
	lda #$3B		; turn graphics mode on
	sta $FF06
	;
	lda $FF07		; PAL/NTSC friendly
	and #$40
	ora #$18		; use $18 for multicolor
	sta $FF07
	;
	lda $FF12
	and #$03		; keep lowest 2 bits (sound)	
	ora #$08		; $08 = $2000, $10 = $4000, etc.
	sta $FF12
	;
	lda #$40		; color map at $4000
	sta $FF14
	;
	lda #$71
	sta $FF15
	;
	lda #$05
	sta $FF16
	;
	cli
	;
main	lda cont		; for most of the intro, the main program does nothing
	jmp main
	;
cont	lda #$CB		; once digi starts, the music is called from the main code once per frame
	cmp $FF1D
	bcs *-3
	;
	jsr irq2_process
	;
	lda #$CB
	cmp $FF1D
	bcc *-3
	jmp cont
	
	align 64
waste_33			; 6 (jsr) + 6 (rts) is already wasted, so we need 21
	nop
	nop
	nop
	nop
	nop
	
	nop
	nop
	nop
	nop
	bit $FF
	rts
	
	;
	; ---
	;
	align 256
irq1	lda $FF1E		; HC increase by 4 for each 1 cycle
	cmp #$B6
	beq ah4			; ahead by 4 cycles (16 HC)
	cmp #$B4
	beq ah3			; ahead by 3 cycles (12 HC)
	cmp #$B2
	beq ah2			; ahead by 2 cycles (8 HC)
	cmp #$AE	
	beq ah1			; ahead by 1 cycle (4 HC)
	cmp #$AA	
	beq ah0			; ahead by 0
	;
ah4	bit $24			; spent 5 checking (was ahead by 4); waste 20
ah3	bit $24			; spent 9 checking (was ahead by 3); waste 15
ah2	bit $24			; spent 13 checking (was ahead by 2); waste 10
ah1	bit $24			; spent 17 checking (was ahead by 1); waste 5
ah0	;			; spent 21 checking
	;
fli_control
	jmp irq1_end		; FLI is off by default
	;
	asl $06
	asl $06
	asl $06
	asl $06
	asl $06
	asl $06
	asl $06
	nop
	nop
	nop
		
	ras $48, $3D
	ras $50, $3F
	ras $58, $39
	;
	ras $40, $3B
	ras $48, $3D
	ras $50, $3F
	ras $58, $39
	;
	ras $40, $3B
	ras $48, $3D
	ras $50, $3F
	ras $58, $39
	;
	ras $40, $3B
	ras $48, $3D
	ras $50, $3F
	ras $58, $39
	;
	ras $40, $3B
	ras $48, $3D
	ras $50, $3F
	ras $58, $39
	;
	ras $40, $3B
	ras $48, $3D
	ras $50, $3F
	ras $58, $39
	;
	ras $40, $3B
	ras $48, $3D
	ras $50, $3F
	ras $58, $39
	;
	ras $40, $3B
	ras $48, $3D
	ras $50, $3F
	ras $58, $39
	;
	ras $40, $3B
	ras $48, $3D
	ras $50, $3F
	ras $58, $39
	;
	ras $40, $3B
	ras $48, $3D
	ras $50, $3F
	ras $58, $39
	;
	ras $40, $3B
	ras $48, $3D
	ras $50, $3F
	ras $58, $39
	;
	ras $40, $3B
	ras $48, $3D
	ras $50, $3F
	ras $58, $39
	;
	ras $40, $3B
	ras $48, $3D
	ras $50, $3F
	ras $58, $39
	;
	ras $40, $3B
	ras $48, $3D
	ras $50, $3F
	ras $58, $39
	;
	ras $40, $3B
	ras $48, $3D
	ras $50, $3F
	ras $58, $39
	;
	ras $40, $3B
	ras $48, $3D
	ras $50, $3F
	ras $58, $39
	;
	lda #$40
	ldx #$3B
	sta $FF14
	stx $FF06
	;
	; ---
	;
irq1_end
	lda #irq2 & 255
	sta $FFFE
	lda #irq2 >> 8
	sta $FFFF
	lda #$A2
	sta $FF0A
irq2_pos
	lda #$CC
	sta $FF0B
	;
	inc $FF09
	rti

	align 256	
irq2	jsr set_irq1
	;
	jsr irq2_process
	;
	lda $FFFE
	cmp #$08
	bne i2
	;
	lda #$4C			; jmp $0000 opcode
	sta main
	;
i2	rti

set_irq1	
	lda #irq1 & 255
	sta $FFFE
	lda #irq1 >> 8
	sta $FFFF
	lda #$A2
	sta $FF0A
	lda #$1C
	sta $FF0B
	inc $FF09
	rts
	
irq2_process
	lda #$7F
	sta $FD30
	sta $FF08
	lda $FF08
	and #$10			; Query keyboard for "Space"
	beq the_end
	;	
	;inc $FF19
	jsr PLAYER
	;dec $FF19
	;
	;dec $FF19
	jsr timeline_process
	;inc $FF19
	;
star_call
	lda star_process		; self-mod
	;
	rts
	
	;
	; -----------------------------
	;
the_end
	sei
	sta $FF3F
	;
	lda #$00
	sta $FF11
	;
	lda #$1B
	sta $FF06
	;
	lda $FF07
	and #$40
	ora #$08
	sta $FF07
	;
	lda #$A2
	sta $FF0A
	;
	lda #$A1
	sta $FF0B
	;
	lda #$C4
	sta $FF12
	;
	lda #$D1
	sta $FF13
	;
	lda #$08
	sta $FF14
	;
	lda #$51
	sta $FF15
	sta $FF19
	;
	ldx #$02
il0b	lda $FC00,x			; restore zero-page variables
	sta $00,x
	inx
	bne il0b
	;
	ldx #$FF			; clear stack
	txs
	;
	inc $FF09
	;
	sta $FF3E
	cli
	;
	; ---
	;
	lda #$01	; logical number
	ldx #$08	; device number (8=disk)
	ldy #$01	; secondary address
	jsr $FFBA	; KERNAL: SETLFS
	;
	lda #fname_end - fname
	ldx #fname & 255
	ldy #fname >> 8
	jsr $FFBD	; KERNAL: SETNAM (Set length and filename address)
	;
	lda #$00	; 0=load
	sta $90		; clear error byte just in case
	jsr $FFD5	; KERNAL: LOADSP (Load from file)
	;
	; --- check for error
	;
	jsr $FFB7	; READSS, find out the status
	cmp #$00	; zero should mean no error
	beq NOERROR
	cmp #$40	; for serial devices, $40 means EOF was reached
	beq NOERROR
	;
	; --- disk error
	;
	lda #$0F
	ldx #$08
	tay
	jsr $FFBA	; KERNAL: SETLFS (Set LA, FA, SA) - OPEN 15, 8, 15
	;
	lda #$00
	jsr $FFBD	; KERNAL: SETNAM - no filename
	;
	jsr $FFC0	; KERNAL: OPEN (Open logical file)
	;
	ldx #$0F
	jsr $FFC6	; KERNAL: CHKIN (Open channel in)
	;
	lda #$80	; read a maximum of 128 chars
	sta $D0
	;
er1	jsr $EC8B	; Read one char
	jsr $FFD2	; KERNAL: BSOUT (Output to channel) - PRINT
	cmp #$0D	; C/R means end of information
	beq er2
	;
	dec $D0		; keep track of the read length to avoid infinite loops
	bne er1
	;
er2	lda #$0F
	jsr $FFC3	; KERNAL: CLOSE (Close logical file)
	;
	lda #$71	; reset colors
	sta $FF15
	lda #$6E
	sta $FF19
	;
	jsr $FF4F
	db "COULD NOT LOAD MAIN PROGRAM."
	db 0
	;
	lda #$00	; clear keyboard buffer
	sta $EF
	;
	jmp $8003	; READY.
	;
NOERROR	lda #$01	; set BASIC vectors to $4000
	sta $2B
	lda #$40
	sta $2C
	;
	lda $9D		; copy load end address to BASIC vectors
	sta $2D
	sta $2F
	sta $31
	lda $9E
	sta $2E
	sta $30
	sta $32
	;
	lda #$80	; flag gfx area allocated
	sta $75
	lda #$03	; mode 3
	sta $65
	lda #$20
	sta $83
	;
	lda #$00	; clear keyboard buffer
	sta $EF
	sta $4000	; ensure basic can run
	;
	jsr $8BBE	; BASIC RUN command
	jmp $8BDC
	
fname
	db "HAUPTPRO*"
fname_end
	;
	; -----------------------------
	;

fli_on
	lda #$2C			; lda $0000 opcode
	sta fli_control
	rts
fli_off
	lda #$4C			; jmp $0000 opcode
	sta fli_control
	lda #$40
	sta $FF14
	rts
	
irq2_to_9D
	lda #$9D
	sta irq2_pos+1
	rts
	
irq2_to_cc
	lda #$cc
	sta irq2_pos+1
	rts

	;
	; ---
	;
	
sprite_save
	lda sprite_pos_ptr
	sta temp_ptr
	lda sprite_pos_ptr+1
	sta temp_ptr+1
	;
	lda temp_ptr
	clc
	adc #$40
	sta temp_ptr+2
	lda temp_ptr+1
	adc #$01
	sta temp_ptr+3
	;
	lda temp_ptr
	clc
	adc #$80
	sta temp_ptr+4
	lda temp_ptr+1
	adc #$02
	sta temp_ptr+5
	;
	ldy #3*8-1
ss1	lda (temp_ptr),y
	sta sprite_saved+3*0*8,y
	lda (temp_ptr+2),y
	sta sprite_saved+3*1*8,y
	lda (temp_ptr+4),y
	sta sprite_saved+3*2*8,y
	dey
	bpl ss1
	;
	rts
	
sprite_restore
	lda sprite_saved		; check if the sprite has been saved previously
	cmp #NO_RESTORE_FLAG		; in this case, skip restoring altogether
	beq sr4
	;
	lda sprite_pos_ptr
	sta temp_ptr
	lda sprite_pos_ptr+1
	sta temp_ptr+1
	;
	lda temp_ptr
	clc
	adc #$40
	sta temp_ptr+2
	lda temp_ptr+1
	adc #$01
	sta temp_ptr+3
	;
	lda temp_ptr
	clc
	adc #$80
	sta temp_ptr+4
	lda temp_ptr+1
	adc #$02
	sta temp_ptr+5
	;
	ldy #3*8-1
sr1	lda sprite_saved+3*0*8,y
	sta (temp_ptr),y
	lda sprite_saved+3*1*8,y
	sta (temp_ptr+2),y
	lda sprite_saved+3*2*8,y
	sta (temp_ptr+4),y
	dey
	bpl sr1
	;
sr4	rts
	
sprite_move
	ldy #$00
	lda (sprite_data_ptr),y
	iny
	sta sprite_pos_ptr
	lda (sprite_data_ptr),y
	iny
	sta sprite_pos_ptr+1
	;
	lda (sprite_data_ptr),y
	iny
	sta sprite_y_offset+1
	lda (sprite_data_ptr),y
	iny
	sta sprite_x_offset+1
	lda (sprite_data_ptr),y
	iny
	sta sprite_size+1
	;
	tya
	clc
	adc sprite_data_ptr
	sta sprite_data_ptr
	bcc *+4
	inc sprite_data_ptr+1
	rts
	
sprite_draw_column
	ldy #$00
sprite_y_offset
	ldx #$00
sd1	
sdp1	lda $2000,x
	and (sprite_mask_ptr),y
	ora (sprite_gfx_ptr),y 
sdp2	sta $2000,x
	iny
	cpy #3*8
	beq sde
	;
	inx
	cpx #$08
	bne sd1
	;
	lda sdp1+1
	clc
	adc #$40
	sta sdp1+1
	sta sdp2+1
	lda sdp1+2
	adc #$01
	sta sdp1+2
	sta sdp2+2
	ldx #$00
	beq sd1
	;
sde	rts
	
sprite_draw
sprite_x_offset
	lda #$00
	clc
sprite_size
	adc #$14
	tax
	lda sprite_mask_lo,x
	sta sprite_mask_ptr
	lda sprite_mask_hi,x
	sta sprite_mask_ptr+1
	;
	lda sprite_gfx_lo,x
	sta sprite_gfx_ptr
	lda sprite_gfx_hi,x
	sta sprite_gfx_ptr+1
	;
	lda sprite_pos_ptr
	sta sdp1+1
	sta sdp2+1
	lda sprite_pos_ptr+1
	sta sdp1+2
	sta sdp2+2
	;
	jsr sprite_draw_column
	;
	lda sprite_mask_ptr
	clc
	adc #3*8
	sta sprite_mask_ptr
	lda sprite_mask_ptr+1
	adc #$00
	sta sprite_mask_ptr+1 
	;
	lda sprite_gfx_ptr
	clc
	adc #3*8
	sta sprite_gfx_ptr
	lda sprite_gfx_ptr+1
	adc #$00
	sta sprite_gfx_ptr+1 
	;
	lda sprite_pos_ptr
	clc
	adc #$08
	sta sdp1+1
	sta sdp2+1
	lda sprite_pos_ptr+1
	adc #$00
	sta sdp1+2
	sta sdp2+2
	;
	jsr sprite_draw_column
	;
	lda sprite_mask_ptr
	clc
	adc #3*8
	sta sprite_mask_ptr
	lda sprite_mask_ptr+1
	adc #$00
	sta sprite_mask_ptr+1 
	;
	lda sprite_gfx_ptr
	clc
	adc #3*8
	sta sprite_gfx_ptr
	lda sprite_gfx_ptr+1
	adc #$00
	sta sprite_gfx_ptr+1 
	;
	lda sprite_pos_ptr
	clc
	adc #$10
	sta sdp1+1
	sta sdp2+1
	lda sprite_pos_ptr+1
	adc #$00
	sta sdp1+2
	sta sdp2+2
	;
	jmp sprite_draw_column

sprite_all	
	jsr sprite_restore
	jsr sprite_move
	jsr sprite_save
	jmp sprite_draw
	
star_process
	lda star_index
	beq star_save
	;
	ldy #$0F
sp1	lda star_saved,y
	and (star_src_ptr),y
	sta (star_screen_ptr),y
	dey
	bpl sp1       
	;
	lda star_src_ptr
	clc
	adc #$10
	sta star_src_ptr
	;
	lda star_index
	clc
	adc #$01
	cmp #15
	bne sp2
	;
	lda #$00
sp2	sta star_index
	;
	rts
	
star_save
	ldx #$01			; x coordinate of the star (in chars)
	ldy #$02			; y coordinate of the star (in chars)
	txa
	asl a				; to calculate the address, we need x*8
	asl a
	asl a
	sta star_x+1
	tya
	asl a				; y=y*2 (for word lookup)
	tay
	lda star_y,y			; get Y address from the tabled, and add X
	clc
star_x	adc #$00
	sta star_screen_ptr
	lda star_y+1,y
	adc #$00
	sta star_screen_ptr+1
	;
	ldy #$0F			; save the background behind the star
ssv1	lda (star_screen_ptr),y
	sta star_saved,y
	dey
	bpl ssv1
	;
	lda #star & 255			; reset the animation pointer
	sta star_src_ptr
	lda #star >> 8
	sta star_src_ptr+1
	;
	inc star_index
	;
	lda star_save+1			; "move" the star to the next coordinate
	clc
	adc #$03			; X+=3
	and #$0F
	cmp #$0B			; but never higher than 11
	bcc ssv2
	sbc #$0B
ssv2	sta star_save+1
	lda star_save+3
	clc
	adc #$07			; Y+=7
	and #$0F			; with these two, the entire logo is covered (somewhat randomly)
	sta star_save+3
	;
	rts
	
star_y
	dw $2000+320* 3+14*8
	dw $2000+320* 4+14*8
	dw $2000+320* 5+14*8
	dw $2000+320* 6+14*8
	
	dw $2000+320* 7+14*8
	dw $2000+320* 8+14*8
	dw $2000+320* 9+14*8
	dw $2000+320*10+14*8
	
	dw $2000+320*11+14*8
	dw $2000+320*12+14*8
	dw $2000+320*13+14*8
	dw $2000+320*14+14*8
	
	dw $2000+320*15+14*8
	dw $2000+320*16+14*8
	dw $2000+320*17+14*8
	dw $2000+320*18+14*8
	
star_start
	lda #$00
	sta star_index
	;
	lda #$20
	sta star_call			; jsr $0000 opcode
	;
	rts
	
set_colors_1
	lda #$10
	db $2C
set_colors_4
	lda #$40
	db $2C
set_colors_8
	lda #$80
	db $2C
set_colors_9
	lda #$90
	db $2C
set_colors_B
	lda #$B0
	sta scb_col+1
	;
	lda #$44
	sta temp_ptr+1
	lda #$4C
	sta temp_ptr+3
	lda #$54
	sta temp_ptr+5
	lda #$5C
	sta temp_ptr+7
	lda #$87
	sta temp_ptr
	sta temp_ptr+2
	sta temp_ptr+4
	sta temp_ptr+6
	;
	ldx #16
scb2	ldy set_colors_width,x
	;
scb_col	lda #$10
scb5	sta (temp_ptr),y
	sta (temp_ptr+2),y
	sta (temp_ptr+4),y
	sta (temp_ptr+6),y
	dey
	bpl scb5
	;
scb6	lda temp_ptr
	clc
	adc #$28
	sta temp_ptr
	sta temp_ptr+2
	sta temp_ptr+4
	sta temp_ptr+6
	bcc *+10
	inc temp_ptr+1
	inc temp_ptr+3
	inc temp_ptr+5
	inc temp_ptr+7
	;
	dex
	cpx #11
	beq scb6
	cpx #5
	beq scb6
	cpx #$00
	bne scb2
	;
	rts
	
set_colors_rainbow
	lda #$44
	sta temp_ptr+1
	lda #$4C
	sta temp_ptr+3
	lda #$54
	sta temp_ptr+5
	lda #$5C
	sta temp_ptr+7
	lda #$87
	sta temp_ptr
	sta temp_ptr+2
	sta temp_ptr+4
	sta temp_ptr+6
	;
	ldx #16
scr2	ldy set_colors_width,x
	;
scr5	lda rainbow_colors,y
	sta (temp_ptr),y
	sta (temp_ptr+2),y
	sta (temp_ptr+4),y
	sta (temp_ptr+6),y
	dey
	bpl scr5
	;
scr6	lda temp_ptr
	clc
	adc #$28
	sta temp_ptr
	sta temp_ptr+2
	sta temp_ptr+4
	sta temp_ptr+6
	bcc *+10
	inc temp_ptr+1
	inc temp_ptr+3
	inc temp_ptr+5
	inc temp_ptr+7
	;
	dex
	cpx #11
	beq scr6
	cpx #5
	beq scr6
	cpx #$00
	bne scr2
	;
	rts
	
rainbow_colors
	db $C0,$50,$F0,$A0,$70,$90,$80,$20,$B0,$40,$E0

set_colors_width	
	db 0,8,8,8,8,8,10,10,10,10,10,10,10,10,10,10,10
	
copy_intro_text
	ldy #$00
	;
	lda intro_text_ptr_data+0,y
	bmi cit4
	sta cit2+1
	lda intro_text_ptr_data+1,y
	sta cit0+1
	;
	lda intro_text_ptr_data+2,y
	sta temp_ptr
	lda intro_text_ptr_data+3,y
	sta temp_ptr+1
	;
	lda intro_text_ptr_data+4,y
	sta temp_ptr+2
	lda intro_text_ptr_data+5,y
	sta temp_ptr+3
	;
	lda copy_intro_text+1
	clc
	adc #$06
	sta copy_intro_text+1 
	;
	ldx #12				; 12 chars wide
cit2	ldy #$00
cit1	lda (temp_ptr),y
	sta (temp_ptr+2),y
	iny
cit0	cpy #$00
	bne cit1
	;
	lda temp_ptr
	clc
	adc #$08
	sta temp_ptr
	bcc *+4
	inc temp_ptr+1
	;
	lda temp_ptr+2
	clc
	adc #$08
	sta temp_ptr+2
	bcc *+4
	inc temp_ptr+3
	;
	dex
	bne cit2
	beq copy_intro_text
	;
cit4	inc copy_intro_text+1
	rts
	
erase_intro_text
	ldy #$00
	;
	lda intro_text_ptr_data+0,y
	bmi eit4
	sta eit2+1
	lda intro_text_ptr_data+1,y
	sta eit0+1
	;
	lda intro_text_ptr_data+4,y
	sta temp_ptr
	lda intro_text_ptr_data+5,y
	sta temp_ptr+1
	;
	lda erase_intro_text+1
	clc
	adc #$06
	sta erase_intro_text+1 
	;
	ldx #12				; 12 chars wide
eit2	ldy #$00
	lda #$00
eit1	sta (temp_ptr),y
	iny
eit0	cpy #$00
	bne eit1
	;
	lda temp_ptr
	clc
	adc #$08
	sta temp_ptr
	bcc *+4
	inc temp_ptr+1
	;
	dex
	bne eit2
	beq erase_intro_text
	;
eit4	inc erase_intro_text+1
	rts
	
set_colors_intro_text_done
	ldx #$46
	ldy #$00
	; X = lum
	; Y = col
set_colors_intro_text
	stx sc_lum+1
	sty sc_col+1
	lda #$03
sc3	pha
	;
	asl a
	asl a
	asl a
	clc
	adc #$40
	sta temp_ptr+1
	ora #$04
	sta temp_ptr+3
	lda #$AE
	sta temp_ptr
	sta temp_ptr+2
	;
	ldx #13
sc2	ldy #$00
sc_lum	lda #$46
	
	sta (temp_ptr),y
	iny
	sta (temp_ptr),y
	iny
	sta (temp_ptr),y
	iny
	sta (temp_ptr),y
	iny
	
	sta (temp_ptr),y
	iny
	sta (temp_ptr),y
	iny
	sta (temp_ptr),y
	iny
	sta (temp_ptr),y
	iny
	
	sta (temp_ptr),y
	iny
	sta (temp_ptr),y
	iny
	sta (temp_ptr),y
	iny
	sta (temp_ptr),y
	;
sc_col	lda #$60
	
	sta (temp_ptr+2),y
	dey
	sta (temp_ptr+2),y
	dey
	sta (temp_ptr+2),y
	dey
	sta (temp_ptr+2),y
	dey
	
	sta (temp_ptr+2),y
	dey
	sta (temp_ptr+2),y
	dey
	sta (temp_ptr+2),y
	dey
	sta (temp_ptr+2),y
	dey
	
	sta (temp_ptr+2),y
	dey
	sta (temp_ptr+2),y
	dey
	sta (temp_ptr+2),y
	dey
	sta (temp_ptr+2),y
	;
	lda temp_ptr
	clc
	adc #$28
	sta temp_ptr
	sta temp_ptr+2
	bcc *+6
	inc temp_ptr+1
	inc temp_ptr+3
	;
	dex
	bpl sc2
	;
	pla
	sec
	sbc #$01
	bpl sc3
	;
	rts
	
copy_credits
	ldx #$00
	txa
	and #$07
	tay
	;
	txa
	lsr a
	lsr a
	lsr a
	tax
	;
	lda credits_lo,x
	sta temp_ptr
	lda credits_hi,x
	sta temp_ptr+1
	;
	lda credits_dst_lo,x
	sta temp_ptr+2
	lda credits_dst_hi,x
	sta temp_ptr+3
	;
	lda credits_len,x
	tax
	;
ccr1	lda (temp_ptr),y
	sta (temp_ptr+2),y
	;
	lda temp_ptr
	clc
	adc #$08
	sta temp_ptr
	bcc *+4
	inc temp_ptr+1
	;
	lda temp_ptr+2
	clc
	adc #$08
	sta temp_ptr+2
	bcc *+4
	inc temp_ptr+3
	;
	dex
	bne ccr1
	;
	inc copy_credits+1
	rts
	
copy_next_letter
	ldx letter_index
	lda letter_src_lo,x
	sta temp_ptr
	lda letter_src_hi,x
	sta temp_ptr+1
	;
	lda letter_dst_lo,x
	sta temp_ptr+2
	lda letter_dst_hi,x
	sta temp_ptr+3
	;
	ldx #7				; 7 chars tall
cnl2	ldy #00

	lda (temp_ptr),y		; copy 40 bytes (5 chars wide); unrolled loop
	sta (temp_ptr+2),y
	iny
	lda (temp_ptr),y
	sta (temp_ptr+2),y
	iny
	lda (temp_ptr),y
	sta (temp_ptr+2),y
	iny
	lda (temp_ptr),y
	sta (temp_ptr+2),y
	iny
	lda (temp_ptr),y
	sta (temp_ptr+2),y
	iny
	lda (temp_ptr),y
	sta (temp_ptr+2),y
	iny
	lda (temp_ptr),y
	sta (temp_ptr+2),y
	iny
	lda (temp_ptr),y
	sta (temp_ptr+2),y
	iny
	lda (temp_ptr),y
	sta (temp_ptr+2),y
	iny
	lda (temp_ptr),y
	sta (temp_ptr+2),y
	iny
	
	;
	
	lda (temp_ptr),y
	sta (temp_ptr+2),y
	iny
	lda (temp_ptr),y
	sta (temp_ptr+2),y
	iny
	lda (temp_ptr),y
	sta (temp_ptr+2),y
	iny
	lda (temp_ptr),y
	sta (temp_ptr+2),y
	iny
	lda (temp_ptr),y
	sta (temp_ptr+2),y
	iny
	lda (temp_ptr),y
	sta (temp_ptr+2),y
	iny
	lda (temp_ptr),y
	sta (temp_ptr+2),y
	iny
	lda (temp_ptr),y
	sta (temp_ptr+2),y
	iny
	lda (temp_ptr),y
	sta (temp_ptr+2),y
	iny
	lda (temp_ptr),y
	sta (temp_ptr+2),y
	iny
	
	;
	
	lda (temp_ptr),y
	sta (temp_ptr+2),y
	iny
	lda (temp_ptr),y
	sta (temp_ptr+2),y
	iny
	lda (temp_ptr),y
	sta (temp_ptr+2),y
	iny
	lda (temp_ptr),y
	sta (temp_ptr+2),y
	iny
	lda (temp_ptr),y
	sta (temp_ptr+2),y
	iny
	lda (temp_ptr),y
	sta (temp_ptr+2),y
	iny
	lda (temp_ptr),y
	sta (temp_ptr+2),y
	iny
	lda (temp_ptr),y
	sta (temp_ptr+2),y
	iny
	lda (temp_ptr),y
	sta (temp_ptr+2),y
	iny
	lda (temp_ptr),y
	sta (temp_ptr+2),y
	iny
	
	;
	
	lda (temp_ptr),y
	sta (temp_ptr+2),y
	iny
	lda (temp_ptr),y
	sta (temp_ptr+2),y
	iny
	lda (temp_ptr),y
	sta (temp_ptr+2),y
	iny
	lda (temp_ptr),y
	sta (temp_ptr+2),y
	iny
	lda (temp_ptr),y
	sta (temp_ptr+2),y
	iny
	lda (temp_ptr),y
	sta (temp_ptr+2),y
	iny
	lda (temp_ptr),y
	sta (temp_ptr+2),y
	iny
	lda (temp_ptr),y
	sta (temp_ptr+2),y
	iny
	lda (temp_ptr),y
	sta (temp_ptr+2),y
	iny
	lda (temp_ptr),y
	sta (temp_ptr+2),y
	
	;
	
	lda temp_ptr
	clc
	adc #5*8
	sta temp_ptr
	bcc *+4
	inc temp_ptr+1
	;
	lda temp_ptr+2
	clc
	adc #$40
	sta temp_ptr+2
	lda temp_ptr+3
	adc #$01
	sta temp_ptr+3
	;
	dex
	beq cnl3
	jmp cnl2 
	;
cnl3	inc letter_index
	;
	lda #NO_RESTORE_FLAG		; flag that in the next frame, we do not need to restore
	sta sprite_saved
	;
	lda #$41
	db $2C	
bg_to_51
	lda #$51
	db $2C
bg_to_61
	lda #$61
	db $2C
bg_to_71
	lda #$71
	sta $FF15
	rts

	org $2000
pic
	include "pic.asm"
	
	org $6000
	
move_fli_colors
mfc0	ldx #$00
	ldy #$3D
mfc1	lda raster_colors,x
	sta colors+$0010,y
	sta colors+$0110,y
	sta colors+$0210,y
	sta colors+$0310,y
	sta colors+$0410,y
	sta colors+$0510,y
	sta colors+$0610,y
	sta colors+$0710,y
	sta colors+$0810,y
	sta colors+$0910,y
	sta colors+$0A10,y
	inx
	dey
	bpl mfc1
	;
	lda mfc0+1
	clc
	adc #$01
	and #$0F
	sta mfc0+1
	;
	jmp copy_fli_colors
	
move_fli_colors_diag
mfcd0	ldx #$00
	ldy #$47
mfcd1	lda raster_colors,x
	sta colors+$0006,y
	sta colors+$0107,y
	sta colors+$0208,y
	sta colors+$0309,y
	sta colors+$040A,y
	sta colors+$050B,y
	sta colors+$060C,y
	sta colors+$070D,y
	sta colors+$080E,y
	sta colors+$090F,y
	sta colors+$0A10,y
	inx
	dey
	bpl mfcd1
	;
	lda mfcd0+1
	clc
	adc #$01
	and #$0F
	sta mfcd0+1
	;
	jmp copy_fli_colors
	
move_fli_colors_center
mfcc0	ldx #$00		; first color: $10 last color: $4D
	ldy #$23
mfcc1	lda raster_colors,x
	sta colors+$0010,y
	sta colors+$010F,y
	sta colors+$020E,y
	sta colors+$030D,y
	sta colors+$040C,y
	sta colors+$050B,y
	sta colors+$060C,y
	sta colors+$070D,y
	sta colors+$080E,y
	sta colors+$090F,y
	sta colors+$0A10,y
	inx
	dey
	bpl mfcc1
	;
	ldx #$2F
	ldy #$1E
mfcc2	lda colors+$0010,y
	sta colors+$0000,x
	lda colors+$0110,y
	sta colors+$0100,x
	lda colors+$0210,y
	sta colors+$0200,x
	lda colors+$0310,y
	sta colors+$0300,x
	lda colors+$0410,y
	sta colors+$0400,x
	lda colors+$0510,y
	sta colors+$0500,x
	lda colors+$0610,y
	sta colors+$0600,x
	lda colors+$0710,y
	sta colors+$0700,x
	lda colors+$0810,y
	sta colors+$0800,x
	lda colors+$0910,y
	sta colors+$0900,x
	lda colors+$0A10,y
	sta colors+$0A00,x
	inx
	dey
	bpl mfcc2
	;
	lda mfcc0+1
	sec
	sbc #$01
	and #$0F
	sta mfcc0+1
	;
	jmp copy_fli_colors
	
move_fli_colors_diag_sine
mfcds0	ldx #$00
	lda raster_sine+0,x
	sta mr0+1
	lda raster_sine+1,x
	sta mr1+1
	lda raster_sine+2,x
	sta mr2+1
	lda raster_sine+3,x
	sta mr3+1
	lda raster_sine+4,x
	sta mr4+1
	lda raster_sine+5,x
	sta mr5+1
	lda raster_sine+6,x
	sta mr6+1
	lda raster_sine+7,x
	sta mr7+1
	lda raster_sine+8,x
	sta mr8+1
	lda raster_sine+9,x
	sta mr9+1
	lda raster_sine+10,x
	sta mrA+1
	;
	ldx #$00
	ldy #$4F
mfcds1	lda raster_colors,x
mr0	sta colors+$0000,y
mr1	sta colors+$0100,y
mr2	sta colors+$0200,y
mr3	sta colors+$0300,y
mr4	sta colors+$0400,y
mr5	sta colors+$0500,y
mr6	sta colors+$0600,y
mr7	sta colors+$0700,y
mr8	sta colors+$0800,y
mr9	sta colors+$0900,y
mrA	sta colors+$0A00,y
	inx
	dey
	bpl mfcds1
	;
	lda mfcds0+1
	clc
	adc #$01
	and #$3F
	sta mfcds0+1
	;
	jmp copy_fli_colors

raster_sine	
; 64,19
	db $13 & 15,$15 & 15,$17 & 15,$19 & 15,$1A & 15,$1C & 15,$1E & 15,$1F & 15,$20 & 15,$22 & 15,$23 & 15,$24 & 15,$25 & 15,$25 & 15,$26 & 15,$26 & 15
	db $26 & 15,$26 & 15,$26 & 15,$25 & 15,$25 & 15,$24 & 15,$23 & 15,$22 & 15,$20 & 15,$1F & 15,$1E & 15,$1C & 15,$1A & 15,$19 & 15,$17 & 15,$15 & 15
	db $13 & 15,$11 & 15,$0F & 15,$0D & 15,$0C & 15,$0A & 15,$08 & 15,$07 & 15,$06 & 15,$04 & 15,$03 & 15,$02 & 15,$01 & 15,$01 & 15,$00 & 15,$00 & 15
	db $00 & 15,$00 & 15,$00 & 15,$01 & 15,$01 & 15,$02 & 15,$03 & 15,$04 & 15,$06 & 15,$07 & 15,$08 & 15,$0A & 15,$0C & 15,$0D & 15,$0F & 15,$11 & 15
	;
	db $13 & 15,$15 & 15,$17 & 15,$19 & 15,$1A & 15,$1C & 15,$1E & 15,$1F & 15,$20 & 15,$22 & 15,$23 & 15,$24 & 15,$25 & 15,$25 & 15,$26 & 15,$26 & 15
	db $26 & 15,$26 & 15,$26 & 15,$25 & 15,$25 & 15,$24 & 15,$23 & 15,$22 & 15,$20 & 15,$1F & 15,$1E & 15,$1C & 15,$1A & 15,$19 & 15,$17 & 15,$15 & 15
	db $13 & 15,$11 & 15,$0F & 15,$0D & 15,$0C & 15,$0A & 15,$08 & 15,$07 & 15,$06 & 15,$04 & 15,$03 & 15,$02 & 15,$01 & 15,$01 & 15,$00 & 15,$00 & 15
	db $00 & 15,$00 & 15,$00 & 15,$01 & 15,$01 & 15,$02 & 15,$03 & 15,$04 & 15,$06 & 15,$07 & 15,$08 & 15,$0A & 15,$0C & 15,$0D & 15,$0F & 15,$11 & 15
	
copy_fli_colors
	lda colors+14+$0002
	sta $5087
	lda colors+14+$0003
	sta $5887
	lda colors+14+$0004
	sta $40AF
	lda colors+14+$0005
	sta $48AF
	lda colors+14+$0006
	sta $50AF
	lda colors+14+$0007
	sta $58AF
	lda colors+14+$0008
	sta $40D7
	lda colors+14+$0009
	sta $48D7
	lda colors+14+$000A
	sta $50D7
	lda colors+14+$000B
	sta $58D7
	lda colors+14+$000C
	sta $40FF
	lda colors+14+$000D
	sta $48FF
	lda colors+14+$000E
	sta $50FF
	lda colors+14+$000F
	sta $58FF
	lda colors+14+$0010
	sta $4127
	lda colors+14+$0011
	sta $4927
	lda colors+14+$0012
	sta $5127
	lda colors+14+$0018
	sta $4177
	lda colors+14+$0019
	sta $4977
	lda colors+14+$001A
	sta $5177
	lda colors+14+$001B
	sta $5977
	lda colors+14+$001C
	sta $419F
	lda colors+14+$001D
	sta $499F
	lda colors+14+$001E
	sta $519F
	lda colors+14+$001F
	sta $599F
	lda colors+14+$0020
	sta $41C7
	lda colors+14+$0021
	sta $49C7
	lda colors+14+$0022
	sta $51C7
	lda colors+14+$0023
	sta $59C7
	lda colors+14+$0024
	sta $41EF
	lda colors+14+$0025
	sta $49EF
	lda colors+14+$0026
	sta $51EF
	lda colors+14+$0027
	sta $59EF
	lda colors+14+$0028
	sta $4217
	;
	; ---
	;
	lda colors+14+$0102
	sta $5088
	lda colors+14+$0103
	sta $5888
	lda colors+14+$0104
	sta $40B0
	lda colors+14+$0105
	sta $48B0
	lda colors+14+$0106
	sta $50B0
	lda colors+14+$010D
	sta $4900
	lda colors+14+$010E
	sta $5100
	lda colors+14+$010F
	sta $5900
	lda colors+14+$0110
	sta $4128
	lda colors+14+$0111
	sta $4928
	lda colors+14+$0112
	sta $5128
	lda colors+14+$0118
	sta $4178
	lda colors+14+$0119
	sta $4978
	lda colors+14+$011A
	sta $5178
	lda colors+14+$011B
	sta $5978
	lda colors+14+$011C
	sta $41A0
	lda colors+14+$011D
	sta $49A0
	lda colors+14+$011E
	sta $51A0
	lda colors+14+$011F
	sta $59A0
	lda colors+14+$0120
	sta $41C8
	lda colors+14+$0121
	sta $49C8
	lda colors+14+$0122
	sta $51C8
	lda colors+14+$0123
	sta $59C8
	lda colors+14+$0124
	sta $41F0
	lda colors+14+$0125
	sta $49F0
	lda colors+14+$0126
	sta $51F0
	lda colors+14+$0127
	sta $59F0
	lda colors+14+$0128
	sta $4218
	lda colors+14+$0131
	sta $4A68
	lda colors+14+$0132
	sta $5268
	lda colors+14+$0133
	sta $5A68
	lda colors+14+$013D
	sta $4AE0
	lda colors+14+$013E
	sta $52E0
	lda colors+14+$013F
	sta $5AE0
	;
	; ---
	;
	lda colors+14+$0202
	sta $5089
	lda colors+14+$0203
	sta $5889
	lda colors+14+$0204
	sta $40B1
	lda colors+14+$0205
	sta $48B1
	lda colors+14+$0206
	sta $50B1
	lda colors+14+$0207
	sta $58B1
	lda colors+14+$0208
	sta $40D9
	lda colors+14+$0209
	sta $48D9
	lda colors+14+$020A
	sta $50D9
	lda colors+14+$020B
	sta $58D9
	lda colors+14+$020C
	sta $4101
	lda colors+14+$020D
	sta $4901
	lda colors+14+$020E
	sta $5101
	lda colors+14+$020F
	sta $5901
	lda colors+14+$0210
	sta $4129
	lda colors+14+$0211
	sta $4929
	lda colors+14+$0212
	sta $5129
	lda colors+14+$0218
	sta $4179
	lda colors+14+$0219
	sta $4979
	lda colors+14+$021A
	sta $5179
	lda colors+14+$021B
	sta $5979
	lda colors+14+$021C
	sta $41A1
	lda colors+14+$021D
	sta $49A1
	lda colors+14+$021E
	sta $51A1
	lda colors+14+$021F
	sta $59A1
	lda colors+14+$0220
	sta $41C9
	lda colors+14+$0221
	sta $49C9
	lda colors+14+$0222
	sta $51C9
	lda colors+14+$0223
	sta $59C9
	lda colors+14+$0224
	sta $41F1
	lda colors+14+$0225
	sta $49F1
	lda colors+14+$0226
	sta $51F1
	lda colors+14+$0227
	sta $59F1
	lda colors+14+$0228
	sta $4219
	lda colors+14+$0230
	sta $4269
	lda colors+14+$0231
	sta $4A69
	lda colors+14+$0232
	sta $5269
	lda colors+14+$0233
	sta $5A69
	lda colors+14+$0234
	sta $4291
	lda colors+14+$0235
	sta $4A91
	lda colors+14+$0236
	sta $5291
	lda colors+14+$0237
	sta $5A91
	lda colors+14+$0238
	sta $42B9
	lda colors+14+$0239
	sta $4AB9
	lda colors+14+$023A
	sta $52B9
	lda colors+14+$023B
	sta $5AB9
	lda colors+14+$023C
	sta $42E1
	lda colors+14+$023D
	sta $4AE1
	lda colors+14+$023E
	sta $52E1
	lda colors+14+$023F
	sta $5AE1
	;
	; ---
	;
	lda colors+14+$0302
	sta $508A
	lda colors+14+$0303
	sta $588A
	lda colors+14+$0304
	sta $40B2
	lda colors+14+$0305
	sta $48B2
	lda colors+14+$0306
	sta $50B2
	lda colors+14+$0307
	sta $58B2
	lda colors+14+$0308
	sta $40DA
	lda colors+14+$0309
	sta $48DA
	lda colors+14+$030A
	sta $50DA
	lda colors+14+$030B
	sta $58DA
	lda colors+14+$030C
	sta $4102
	lda colors+14+$030D
	sta $4902
	lda colors+14+$030E
	sta $5102
	lda colors+14+$030F
	sta $5902
	lda colors+14+$0310
	sta $412A
	lda colors+14+$0311
	sta $492A
	lda colors+14+$0312
	sta $512A
	lda colors+14+$0319
	sta $497A
	lda colors+14+$031A
	sta $517A
	lda colors+14+$031B
	sta $597A
	lda colors+14+$031C
	sta $41A2
	lda colors+14+$031D
	sta $49A2
	lda colors+14+$031E
	sta $51A2
	lda colors+14+$031F
	sta $59A2
	lda colors+14+$0320
	sta $41CA
	lda colors+14+$0321
	sta $49CA
	lda colors+14+$0322
	sta $51CA
	lda colors+14+$0323
	sta $59CA
	lda colors+14+$0324
	sta $41F2
	lda colors+14+$0325
	sta $49F2
	lda colors+14+$0326
	sta $51F2
	lda colors+14+$0327
	sta $59F2
	lda colors+14+$0328
	sta $421A
	lda colors+14+$033B
	sta $5ABA
	lda colors+14+$033C
	sta $42E2
	lda colors+14+$033D
	sta $4AE2
	lda colors+14+$033E
	sta $52E2
	lda colors+14+$033F
	sta $5AE2
	;
	; ---
	;
	lda colors+14+$040C
	sta $4103
	lda colors+14+$040D
	sta $4903
	lda colors+14+$040E
	sta $5103
	lda colors+14+$040F
	sta $5903
	lda colors+14+$0410
	sta $412B
	lda colors+14+$0411
	sta $492B
	lda colors+14+$0412
	sta $512B
	lda colors+14+$0419
	sta $497B
	lda colors+14+$041A
	sta $517B
	lda colors+14+$041B
	sta $597B
	lda colors+14+$041C
	sta $41A3
	lda colors+14+$041D
	sta $49A3
	lda colors+14+$041E
	sta $51A3
	lda colors+14+$041F
	sta $59A3
	lda colors+14+$0420
	sta $41CB
	lda colors+14+$0421
	sta $49CB
	lda colors+14+$0422
	sta $51CB
	lda colors+14+$0423
	sta $59CB
	lda colors+14+$0424
	sta $41F3
	lda colors+14+$0425
	sta $49F3
	lda colors+14+$0426
	sta $51F3
	lda colors+14+$0427
	sta $59F3
	lda colors+14+$0428
	sta $421B
	lda colors+14+$0430
	sta $426B
	lda colors+14+$0431
	sta $4A6B
	lda colors+14+$0432
	sta $526B
	lda colors+14+$0433
	sta $5A6B
	lda colors+14+$0434
	sta $4293
	lda colors+14+$0435
	sta $4A93
	lda colors+14+$0436
	sta $5293
	lda colors+14+$0437
	sta $5A93
	lda colors+14+$0438
	sta $42BB
	lda colors+14+$043B
	sta $5ABB
	lda colors+14+$043C
	sta $42E3
	lda colors+14+$043D
	sta $4AE3
	lda colors+14+$043E
	sta $52E3
	lda colors+14+$043F
	sta $5AE3
	;
	; ---
	;
	lda colors+14+$0502
	sta $508C
	lda colors+14+$0503
	sta $588C
	lda colors+14+$0504
	sta $40B4
	lda colors+14+$0505
	sta $48B4
	lda colors+14+$0506
	sta $50B4
	lda colors+14+$0507
	sta $58B4
	lda colors+14+$0508
	sta $40DC
	lda colors+14+$0509
	sta $48DC
	lda colors+14+$050A
	sta $50DC
	lda colors+14+$050B
	sta $58DC
	lda colors+14+$050C
	sta $4104
	lda colors+14+$050D
	sta $4904
	lda colors+14+$050E
	sta $5104
	lda colors+14+$050F
	sta $5904
	lda colors+14+$0510
	sta $412C
	lda colors+14+$0511
	sta $492C
	lda colors+14+$0512
	sta $512C
	lda colors+14+$0519
	sta $497C
	lda colors+14+$051A
	sta $517C
	lda colors+14+$051B
	sta $597C
	lda colors+14+$051C
	sta $41A4
	lda colors+14+$051D
	sta $49A4
	lda colors+14+$051E
	sta $51A4
	lda colors+14+$051F
	sta $59A4
	lda colors+14+$0520
	sta $41CC
	lda colors+14+$0521
	sta $49CC
	lda colors+14+$0522
	sta $51CC
	lda colors+14+$0523
	sta $59CC
	lda colors+14+$0524
	sta $41F4
	lda colors+14+$0525
	sta $49F4
	lda colors+14+$0526
	sta $51F4
	lda colors+14+$0527
	sta $59F4
	lda colors+14+$0528
	sta $421C
	lda colors+14+$0530
	sta $426C
	lda colors+14+$0531
	sta $4A6C
	lda colors+14+$0532
	sta $526C
	lda colors+14+$0533
	sta $5A6C
	lda colors+14+$0535
	sta $4A94
	lda colors+14+$0536
	sta $5294
	lda colors+14+$0537
	sta $5A94
	lda colors+14+$0538
	sta $42BC
	lda colors+14+$0539
	sta $4ABC
	lda colors+14+$053A
	sta $52BC
	lda colors+14+$053B
	sta $5ABC
	lda colors+14+$053C
	sta $42E4
	lda colors+14+$053D
	sta $4AE4
	lda colors+14+$053E
	sta $52E4
	lda colors+14+$053F
	;
	; ---
	;
	sta $5AE4
	lda colors+14+$0602
	sta $508D
	lda colors+14+$0603
	sta $588D
	lda colors+14+$0604
	sta $40B5
	lda colors+14+$0605
	sta $48B5
	lda colors+14+$0606
	sta $50B5
	lda colors+14+$0607
	sta $58B5
	lda colors+14+$0608
	sta $40DD
	lda colors+14+$0609
	sta $48DD
	lda colors+14+$060A
	sta $50DD
	lda colors+14+$060B
	sta $58DD
	lda colors+14+$060C
	sta $4105
	lda colors+14+$060D
	sta $4905
	lda colors+14+$060E
	sta $5105
	lda colors+14+$060F
	sta $5905
	lda colors+14+$0610
	sta $412D
	lda colors+14+$0611
	sta $492D
	lda colors+14+$0612
	sta $512D
	lda colors+14+$0618
	sta $417D
	lda colors+14+$0619
	sta $497D
	lda colors+14+$061A
	sta $517D
	lda colors+14+$061B
	sta $597D
	lda colors+14+$061C
	sta $41A5
	lda colors+14+$061D
	sta $49A5
	lda colors+14+$061E
	sta $51A5
	lda colors+14+$061F
	sta $59A5
	lda colors+14+$0620
	sta $41CD
	lda colors+14+$0621
	sta $49CD
	lda colors+14+$0622
	sta $51CD
	lda colors+14+$0623
	sta $59CD
	lda colors+14+$0624
	sta $41F5
	lda colors+14+$0625
	sta $49F5
	lda colors+14+$0626
	sta $51F5
	lda colors+14+$0627
	sta $59F5
	lda colors+14+$0628
	sta $421D
	lda colors+14+$0630
	sta $426D
	lda colors+14+$0631
	sta $4A6D
	lda colors+14+$0632
	sta $526D
	lda colors+14+$0633
	sta $5A6D
	lda colors+14+$0634
	sta $4295
	lda colors+14+$0635
	sta $4A95
	lda colors+14+$0636
	sta $5295
	lda colors+14+$0637
	sta $5A95
	lda colors+14+$0638
	sta $42BD
	lda colors+14+$0639
	sta $4ABD
	lda colors+14+$063A
	sta $52BD
	lda colors+14+$063B
	sta $5ABD
	lda colors+14+$063C
	sta $42E5
	lda colors+14+$063D
	sta $4AE5
	lda colors+14+$063E
	sta $52E5
	lda colors+14+$063F
	sta $5AE5
	;
	; ---
	;
	lda colors+14+$0702
	sta $508E
	lda colors+14+$0703
	sta $588E
	lda colors+14+$0704
	sta $40B6
	lda colors+14+$0705
	sta $48B6
	lda colors+14+$0706
	sta $50B6
	lda colors+14+$0707
	sta $58B6
	lda colors+14+$0708
	sta $40DE
	lda colors+14+$0709
	sta $48DE
	lda colors+14+$070A
	sta $50DE
	lda colors+14+$070B
	sta $58DE
	lda colors+14+$070C
	sta $4106
	lda colors+14+$070D
	sta $4906
	lda colors+14+$070E
	sta $5106
	lda colors+14+$070F
	sta $5906
	lda colors+14+$0710
	sta $412E
	lda colors+14+$0711
	sta $492E
	lda colors+14+$0712
	sta $512E
	lda colors+14+$0718
	sta $417E
	lda colors+14+$0719
	sta $497E
	lda colors+14+$071A
	sta $517E
	lda colors+14+$071B
	sta $597E
	lda colors+14+$071C
	sta $41A6
	lda colors+14+$071D
	sta $49A6
	lda colors+14+$071F
	sta $59A6
	lda colors+14+$0720
	sta $41CE
	lda colors+14+$0721
	sta $49CE
	lda colors+14+$0730
	sta $426E
	lda colors+14+$0731
	sta $4A6E
	lda colors+14+$0732
	sta $526E
	lda colors+14+$0733
	sta $5A6E
	lda colors+14+$0734
	sta $4296
	lda colors+14+$0735
	sta $4A96
	lda colors+14+$0736
	sta $5296
	lda colors+14+$0737
	sta $5A96
	lda colors+14+$0738
	sta $42BE
	lda colors+14+$0739
	sta $4ABE
	lda colors+14+$073A
	sta $52BE
	lda colors+14+$073B
	sta $5ABE
	lda colors+14+$073C
	sta $42E6
	lda colors+14+$073D
	sta $4AE6
	lda colors+14+$073E
	sta $52E6
	lda colors+14+$073F
	;
	; ---
	;
	sta $5AE6
	lda colors+14+$0802
	sta $508F
	lda colors+14+$0803
	sta $588F
	lda colors+14+$0804
	sta $40B7
	lda colors+14+$0805
	sta $48B7
	lda colors+14+$0806
	sta $50B7
	lda colors+14+$0807
	sta $58B7
	lda colors+14+$0808
	sta $40DF
	lda colors+14+$0809
	sta $48DF
	lda colors+14+$080A
	sta $50DF
	lda colors+14+$080B
	sta $58DF
	lda colors+14+$080C
	sta $4107
	lda colors+14+$080D
	sta $4907
	lda colors+14+$080E
	sta $5107
	lda colors+14+$080F
	sta $5907
	lda colors+14+$0810
	sta $412F
	lda colors+14+$0811
	sta $492F
	lda colors+14+$0812
	sta $512F
	lda colors+14+$0819
	sta $497F
	lda colors+14+$081A
	sta $517F
	lda colors+14+$081B
	sta $597F
	lda colors+14+$081C
	sta $41A7
	lda colors+14+$081D
	sta $49A7
	lda colors+14+$081E
	sta $51A7
	lda colors+14+$081F
	sta $59A7
	lda colors+14+$0820
	sta $41CF
	lda colors+14+$0821
	sta $49CF
	lda colors+14+$0822
	sta $51CF
	lda colors+14+$0823
	sta $59CF
	lda colors+14+$0824
	sta $41F7
	lda colors+14+$0825
	sta $49F7
	lda colors+14+$0826
	sta $51F7
	lda colors+14+$0827
	sta $59F7
	lda colors+14+$0828
	sta $421F
	lda colors+14+$0830
	sta $426F
	lda colors+14+$0831
	sta $4A6F
	lda colors+14+$0832
	sta $526F
	lda colors+14+$0833
	sta $5A6F
	lda colors+14+$0834
	sta $4297
	lda colors+14+$0835
	sta $4A97
	lda colors+14+$0836
	sta $5297
	lda colors+14+$0837
	sta $5A97
	lda colors+14+$0838
	sta $42BF
	lda colors+14+$0839
	sta $4ABF
	lda colors+14+$083A
	sta $52BF
	lda colors+14+$083B
	sta $5ABF
	lda colors+14+$083C
	sta $42E7
	lda colors+14+$083D
	sta $4AE7
	lda colors+14+$083E
	sta $52E7
	lda colors+14+$083F
	;
	; ---
	;
	sta $5AE7
	lda colors+14+$0902
	sta $5090
	lda colors+14+$0903
	sta $5890
	lda colors+14+$0904
	sta $40B8
	lda colors+14+$0905
	sta $48B8
	lda colors+14+$0906
	sta $50B8
	lda colors+14+$0907
	sta $58B8
	lda colors+14+$0908
	sta $40E0
	lda colors+14+$0909
	sta $48E0
	lda colors+14+$090A
	sta $50E0
	lda colors+14+$090B
	sta $58E0
	lda colors+14+$090C
	sta $4108
	lda colors+14+$090D
	sta $4908
	lda colors+14+$090E
	sta $5108
	lda colors+14+$090F
	sta $5908
	lda colors+14+$0910
	sta $4130
	lda colors+14+$0911
	sta $4930
	lda colors+14+$0912
	sta $5130
	lda colors+14+$0918
	sta $4180
	lda colors+14+$0919
	sta $4980
	lda colors+14+$091A
	sta $5180
	lda colors+14+$091B
	sta $5980
	lda colors+14+$091C
	sta $41A8
	lda colors+14+$091D
	sta $49A8
	lda colors+14+$091E
	sta $51A8
	lda colors+14+$091F
	sta $59A8
	lda colors+14+$0920
	sta $41D0
	lda colors+14+$0921
	sta $49D0
	lda colors+14+$0922
	sta $51D0
	lda colors+14+$0923
	sta $59D0
	lda colors+14+$0924
	sta $41F8
	lda colors+14+$0925
	sta $49F8
	lda colors+14+$0926
	sta $51F8
	lda colors+14+$0927
	sta $59F8
	lda colors+14+$0928
	;
	; ---
	;
	sta $4220
	lda colors+14+$0A02
	sta $5091
	lda colors+14+$0A03
	sta $5891
	lda colors+14+$0A04
	sta $40B9
	lda colors+14+$0A05
	sta $48B9
	lda colors+14+$0A06
	sta $50B9
	lda colors+14+$0A07
	sta $58B9
	lda colors+14+$0A08
	sta $40E1
	lda colors+14+$0A09
	sta $48E1
	lda colors+14+$0A0A
	sta $50E1
	lda colors+14+$0A0B
	sta $58E1
	lda colors+14+$0A0C
	sta $4109
	lda colors+14+$0A0D
	sta $4909
	lda colors+14+$0A0E
	sta $5109
	lda colors+14+$0A0F
	sta $5909
	lda colors+14+$0A10
	sta $4131
	lda colors+14+$0A11
	sta $4931
	lda colors+14+$0A19
	sta $4981
	lda colors+14+$0A1A
	sta $5181
	lda colors+14+$0A1B
	sta $5981
	lda colors+14+$0A1C
	sta $41A9
	lda colors+14+$0A1D
	sta $49A9
	lda colors+14+$0A1E
	sta $51A9
	lda colors+14+$0A1F
	sta $59A9
	lda colors+14+$0A20
	sta $41D1
	lda colors+14+$0A21
	sta $49D1
	lda colors+14+$0A22
	sta $51D1
	lda colors+14+$0A23
	sta $59D1
	lda colors+14+$0A24
	sta $41F9
	lda colors+14+$0A25
	sta $49F9
	lda colors+14+$0A26
	sta $51F9
	lda colors+14+$0A27
	sta $59F9
	lda colors+14+$0A28
	sta $4221
	rts
	
	align 256	
plasma_colors
	db $40,$41,$42,$43,$44,$45,$46,$47,$47,$46,$45,$44,$43,$42,$41,$40
	db $B0,$B1,$B2,$B3,$B4,$B5,$B6,$B7,$B7,$B6,$B5,$B4,$B3,$B2,$B1,$B0
	db $20,$21,$22,$23,$24,$25,$26,$27,$27,$26,$25,$24,$23,$22,$21,$20
	db $80,$81,$82,$83,$84,$85,$86,$87,$87,$86,$85,$84,$83,$82,$81,$80
	;
	db $90,$91,$92,$93,$94,$95,$96,$97,$97,$96,$95,$94,$93,$92,$91,$90
	db $80,$81,$82,$83,$84,$85,$86,$87,$87,$86,$85,$84,$83,$82,$81,$80
	db $20,$21,$22,$23,$24,$25,$26,$27,$27,$26,$25,$24,$23,$22,$21,$20
	db $B0,$B1,$B2,$B3,$B4,$B5,$B6,$B7,$B7,$B6,$B5,$B4,$B3,$B2,$B1,$B0
	;
	db $40,$41,$42,$43,$44,$45,$46,$47,$47,$46,$45,$44,$43,$42,$41,$40
	db $B0,$B1,$B2,$B3,$B4,$B5,$B6,$B7,$B7,$B6,$B5,$B4,$B3,$B2,$B1,$B0
	db $20,$21,$22,$23,$24,$25,$26,$27,$27,$26,$25,$24,$23,$22,$21,$20
	db $80,$81,$82,$83,$84,$85,$86,$87,$87,$86,$85,$84,$83,$82,$81,$80
	;
	db $90,$91,$92,$93,$94,$95,$96,$97,$97,$96,$95,$94,$93,$92,$91,$90
	db $80,$81,$82,$83,$84,$85,$86,$87,$87,$86,$85,$84,$83,$82,$81,$80
	db $20,$21,$22,$23,$24,$25,$26,$27,$27,$26,$25,$24,$23,$22,$21,$20
	db $B0,$B1,$B2,$B3,$B4,$B5,$B6,$B7,$B7,$B6,$B5,$B4,$B3,$B2,$B1,$B0
	
plasma_sine_y
; 100,30
	db $1E,$20,$22,$24,$25,$27,$29,$2B,$2C,$2E,$30,$31,$33,$34,$35,$36
	db $37,$38,$39,$3A,$3B,$3B,$3B,$3C,$3C,$3C,$3C,$3C,$3B,$3B,$3B,$3A
	db $39,$38,$37,$36,$35,$34,$33,$31,$30,$2E,$2C,$2B,$29,$27,$25,$24
	db $22,$20,$1E,$1C,$1A,$18,$17,$15,$13,$11,$10,$0E,$0C,$0B,$09,$08
	db $07,$06,$05,$04,$03,$02,$01,$01,$01,$00,$00,$00,$00,$00,$01,$01
	db $01,$02,$03,$04,$05,$06,$07,$08,$09,$0B,$0C,$0E,$10,$11,$13,$15
	db $17,$18,$1A,$1C
	;
	db $1E,$20,$22,$24,$25,$27,$29,$2B,$2C,$2E,$30,$31,$33,$34,$35,$36
	db $37,$38,$39,$3A,$3B,$3B,$3B,$3C,$3C,$3C,$3C,$3C,$3B,$3B,$3B,$3A
	db $39,$38,$37,$36,$35,$34,$33,$31,$30,$2E,$2C,$2B,$29,$27,$25,$24
	db $22,$20,$1E,$1C,$1A,$18,$17,$15,$13,$11,$10,$0E,$0C,$0B,$09,$08
	db $07,$06,$05,$04,$03,$02,$01,$01,$01,$00,$00,$00,$00,$00,$01,$01
	db $01,$02,$03,$04,$05,$06,$07,$08,$09,$0B,$0C,$0E,$10,$11,$13,$15
	db $17,$18,$1A,$1C
	
	align 256
plasma_sine_x
; 85,14
	db $0E,$0F,$10,$11,$12,$13,$14,$15,$16,$17,$17,$18,$19,$19,$1A,$1B
	db $1B,$1B,$1C,$1C,$1C,$1C,$1C,$1C,$1C,$1B,$1B,$1B,$1A,$1A,$19,$19
	db $18,$17,$16,$15,$14,$14,$13,$12,$11,$10,$0F,$0D,$0C,$0B,$0A,$09
	db $08,$08,$07,$06,$05,$04,$03,$03,$02,$02,$01,$01,$01,$00,$00,$00
	db $00,$00,$00,$00,$01,$01,$01,$02,$03,$03,$04,$05,$05,$06,$07,$08
	db $09,$0A,$0B,$0C,$0D
	;
	db $0E,$0F,$10,$11,$12,$13,$14,$15,$16,$17,$17,$18,$19,$19,$1A,$1B
	db $1B,$1B,$1C,$1C,$1C,$1C,$1C,$1C,$1C,$1B,$1B,$1B,$1A,$1A,$19,$19
	db $18,$17,$16,$15,$14,$14,$13,$12,$11,$10,$0F,$0D,$0C,$0B,$0A,$09
	db $08,$08,$07,$06,$05,$04,$03,$03,$02,$02,$01,$01,$01,$00,$00,$00
	db $00,$00,$00,$00,$01,$01,$01,$02,$03,$03,$04,$05,$05,$06,$07,$08
	db $09,$0A,$0B,$0C,$0D
	
fp	macro yp,xp,adr
	lda plasma+yp
	adc plasma_sine_y+xp,y
	adc #yp
	tax
	lda plasma_colors,x
	sta adr
	and #$F0
	sta $4400+((adr+$800)&$1FFF)
	endm
	
fli_plasma
	lda fp2+1
	sec
	sbc #$01
	bpl *+4
	lda #84
	sta fp2+1
	;
fp2	ldy #44
	lda plasma_sine_x+0,y
	sta plasma+0
	lda plasma_sine_x+3,y
	sta plasma+1
	lda plasma_sine_x+6,y
	sta plasma+2
	lda plasma_sine_x+9,y
	sta plasma+3
	lda plasma_sine_x+12,y
	sta plasma+4
	lda plasma_sine_x+15,y
	sta plasma+5
	lda plasma_sine_x+18,y
	sta plasma+6
	lda plasma_sine_x+21,y
	sta plasma+7
	lda plasma_sine_x+24,y
	sta plasma+8
	lda plasma_sine_x+27,y
	sta plasma+9
	lda plasma_sine_x+30,y
	sta plasma+10
	;
	lda fp1+1
	clc
	adc #$01
	cmp #100
	bcc *+4
	lda #$00
	sta fp1+1
	;
fp1	ldy #$00
	fp $00,$02,$5087
	fp $00,$03,$5887
	fp $00,$04,$40AF
	fp $00,$05,$48AF
	fp $00,$06,$50AF
	fp $00,$07,$58AF
	fp $00,$08,$40D7
	fp $00,$09,$48D7
	fp $00,$0A,$50D7
	fp $00,$0B,$58D7
	fp $00,$0C,$40FF
	fp $00,$0D,$48FF
	fp $00,$0E,$50FF
	fp $00,$0F,$58FF
	fp $00,$10,$4127
	fp $00,$11,$4927
	fp $00,$12,$5127
	fp $00,$18,$4177
	fp $00,$19,$4977
	fp $00,$1A,$5177
	fp $00,$1B,$5977
	fp $00,$1C,$419F
	fp $00,$1D,$499F
	fp $00,$1E,$519F
	fp $00,$1F,$599F
	fp $00,$20,$41C7
	fp $00,$21,$49C7
	fp $00,$22,$51C7
	fp $00,$23,$59C7
	fp $00,$24,$41EF
	fp $00,$25,$49EF
	fp $00,$26,$51EF
	fp $00,$27,$59EF
	fp $00,$28,$4217
	;
	; ---
	;
	fp $01,$02,$5088
	fp $01,$03,$5888
	fp $01,$04,$40B0
	fp $01,$05,$48B0
	fp $01,$06,$50B0
	fp $01,$0D,$4900
	fp $01,$0E,$5100
	fp $01,$0F,$5900
	fp $01,$10,$4128
	fp $01,$11,$4928
	fp $01,$12,$5128
	fp $01,$18,$4178
	fp $01,$19,$4978
	fp $01,$1A,$5178
	fp $01,$1B,$5978
	fp $01,$1C,$41A0
	fp $01,$1D,$49A0
	fp $01,$1E,$51A0
	fp $01,$1F,$59A0
	fp $01,$20,$41C8
	fp $01,$21,$49C8
	fp $01,$22,$51C8
	fp $01,$23,$59C8
	fp $01,$24,$41F0
	fp $01,$25,$49F0
	fp $01,$26,$51F0
	fp $01,$27,$59F0
	fp $01,$28,$4218
	fp $01,$31,$4A68
	fp $01,$32,$5268
	fp $01,$33,$5A68
	fp $01,$3D,$4AE0
	fp $01,$3E,$52E0
	fp $01,$3F,$5AE0
	;
	; ---
	;
	fp $02,$02,$5089
	fp $02,$03,$5889
	fp $02,$04,$40B1
	fp $02,$05,$48B1
	fp $02,$06,$50B1
	fp $02,$07,$58B1
	fp $02,$08,$40D9
	fp $02,$09,$48D9
	fp $02,$0A,$50D9
	fp $02,$0B,$58D9
	fp $02,$0C,$4101
	fp $02,$0D,$4901
	fp $02,$0E,$5101
	fp $02,$0F,$5901
	fp $02,$10,$4129
	fp $02,$11,$4929
	fp $02,$12,$5129
	fp $02,$18,$4179
	fp $02,$19,$4979
	fp $02,$1A,$5179
	fp $02,$1B,$5979
	fp $02,$1C,$41A1
	fp $02,$1D,$49A1
	fp $02,$1E,$51A1
	fp $02,$1F,$59A1
	fp $02,$20,$41C9
	fp $02,$21,$49C9
	fp $02,$22,$51C9
	fp $02,$23,$59C9
	fp $02,$24,$41F1
	fp $02,$25,$49F1
	fp $02,$26,$51F1
	fp $02,$27,$59F1
	fp $02,$28,$4219
	fp $02,$30,$4269
	fp $02,$31,$4A69
	fp $02,$32,$5269
	fp $02,$33,$5A69
	fp $02,$34,$4291
	fp $02,$35,$4A91
	fp $02,$36,$5291
	fp $02,$37,$5A91
	fp $02,$38,$42B9
	fp $02,$39,$4AB9
	fp $02,$3A,$52B9
	fp $02,$3B,$5AB9
	fp $02,$3C,$42E1
	fp $02,$3D,$4AE1
	fp $02,$3E,$52E1
	fp $02,$3F,$5AE1
	;
	; ---
	;
	fp $03,$02,$508A
	fp $03,$03,$588A
	fp $03,$04,$40B2
	fp $03,$05,$48B2
	fp $03,$06,$50B2
	fp $03,$07,$58B2
	fp $03,$08,$40DA
	fp $03,$09,$48DA
	fp $03,$0A,$50DA
	fp $03,$0B,$58DA
	fp $03,$0C,$4102
	fp $03,$0D,$4902
	fp $03,$0E,$5102
	fp $03,$0F,$5902
	fp $03,$10,$412A
	fp $03,$11,$492A
	fp $03,$12,$512A
	fp $03,$19,$497A
	fp $03,$1A,$517A
	fp $03,$1B,$597A
	fp $03,$1C,$41A2
	fp $03,$1D,$49A2
	fp $03,$1E,$51A2
	fp $03,$1F,$59A2
	fp $03,$20,$41CA
	fp $03,$21,$49CA
	fp $03,$22,$51CA
	fp $03,$23,$59CA
	fp $03,$24,$41F2
	fp $03,$25,$49F2
	fp $03,$26,$51F2
	fp $03,$27,$59F2
	fp $03,$28,$421A
	fp $03,$3B,$5ABA
	fp $03,$3C,$42E2
	fp $03,$3D,$4AE2
	fp $03,$3E,$52E2
	fp $03,$3F,$5AE2
	;
	; ---
	;
	fp $04,$0C,$4103
	fp $04,$0D,$4903
	fp $04,$0E,$5103
	fp $04,$0F,$5903
	fp $04,$10,$412B
	fp $04,$11,$492B
	fp $04,$12,$512B
	fp $04,$19,$497B
	fp $04,$1A,$517B
	fp $04,$1B,$597B
	fp $04,$1C,$41A3
	fp $04,$1D,$49A3
	fp $04,$1E,$51A3
	fp $04,$1F,$59A3
	fp $04,$20,$41CB
	fp $04,$21,$49CB
	fp $04,$22,$51CB
	fp $04,$23,$59CB
	fp $04,$24,$41F3
	fp $04,$25,$49F3
	fp $04,$26,$51F3
	fp $04,$27,$59F3
	fp $04,$28,$421B
	fp $04,$30,$426B
	fp $04,$31,$4A6B
	fp $04,$32,$526B
	fp $04,$33,$5A6B
	fp $04,$34,$4293
	fp $04,$35,$4A93
	fp $04,$36,$5293
	fp $04,$37,$5A93
	fp $04,$38,$42BB
	fp $04,$3B,$5ABB
	fp $04,$3C,$42E3
	fp $04,$3D,$4AE3
	fp $04,$3E,$52E3
	fp $04,$3F,$5AE3
	;
	; ---
	;
	fp $05,$02,$508C
	fp $05,$03,$588C
	fp $05,$04,$40B4
	fp $05,$05,$48B4
	fp $05,$06,$50B4
	fp $05,$07,$58B4
	fp $05,$08,$40DC
	fp $05,$09,$48DC
	fp $05,$0A,$50DC
	fp $05,$0B,$58DC
	fp $05,$0C,$4104
	fp $05,$0D,$4904
	fp $05,$0E,$5104
	fp $05,$0F,$5904
	fp $05,$10,$412C
	fp $05,$11,$492C
	fp $05,$12,$512C
	fp $05,$19,$497C
	fp $05,$1A,$517C
	fp $05,$1B,$597C
	fp $05,$1C,$41A4
	fp $05,$1D,$49A4
	fp $05,$1E,$51A4
	fp $05,$1F,$59A4
	fp $05,$20,$41CC
	fp $05,$21,$49CC
	fp $05,$22,$51CC
	fp $05,$23,$59CC
	fp $05,$24,$41F4
	fp $05,$25,$49F4
	fp $05,$26,$51F4
	fp $05,$27,$59F4
	fp $05,$28,$421C
	fp $05,$30,$426C
	fp $05,$31,$4A6C
	fp $05,$32,$526C
	fp $05,$33,$5A6C
	fp $05,$35,$4A94
	fp $05,$36,$5294
	fp $05,$37,$5A94
	fp $05,$38,$42BC
	fp $05,$39,$4ABC
	fp $05,$3A,$52BC
	fp $05,$3B,$5ABC
	fp $05,$3C,$42E4
	fp $05,$3D,$4AE4
	fp $05,$3E,$52E4
	fp $05,$3F,$5AE4
	;
	; ---
	;
	fp $06,$02,$508D
	fp $06,$03,$588D
	fp $06,$04,$40B5
	fp $06,$05,$48B5
	fp $06,$06,$50B5
	fp $06,$07,$58B5
	fp $06,$08,$40DD
	fp $06,$09,$48DD
	fp $06,$0A,$50DD
	fp $06,$0B,$58DD
	fp $06,$0C,$4105
	fp $06,$0D,$4905
	fp $06,$0E,$5105
	fp $06,$0F,$5905
	fp $06,$10,$412D
	fp $06,$11,$492D
	fp $06,$12,$512D
	fp $06,$18,$417D
	fp $06,$19,$497D
	fp $06,$1A,$517D
	fp $06,$1B,$597D
	fp $06,$1C,$41A5
	fp $06,$1D,$49A5
	fp $06,$1E,$51A5
	fp $06,$1F,$59A5
	fp $06,$20,$41CD
	fp $06,$21,$49CD
	fp $06,$22,$51CD
	fp $06,$23,$59CD
	fp $06,$24,$41F5
	fp $06,$25,$49F5
	fp $06,$26,$51F5
	fp $06,$27,$59F5
	fp $06,$28,$421D
	fp $06,$30,$426D
	fp $06,$31,$4A6D
	fp $06,$32,$526D
	fp $06,$33,$5A6D
	fp $06,$34,$4295
	fp $06,$35,$4A95
	fp $06,$36,$5295
	fp $06,$37,$5A95
	fp $06,$38,$42BD
	fp $06,$39,$4ABD
	fp $06,$3A,$52BD
	fp $06,$3B,$5ABD
	fp $06,$3C,$42E5
	fp $06,$3D,$4AE5
	fp $06,$3E,$52E5
	fp $06,$3F,$5AE5
	;
	; ---
	;
	fp $07,$02,$508E
	fp $07,$03,$588E
	fp $07,$04,$40B6
	fp $07,$05,$48B6
	fp $07,$06,$50B6
	fp $07,$07,$58B6
	fp $07,$08,$40DE
	fp $07,$09,$48DE
	fp $07,$0A,$50DE
	fp $07,$0B,$58DE
	fp $07,$0C,$4106
	fp $07,$0D,$4906
	fp $07,$0E,$5106
	fp $07,$0F,$5906
	fp $07,$10,$412E
	fp $07,$11,$492E
	fp $07,$12,$512E
	fp $07,$18,$417E
	fp $07,$19,$497E
	fp $07,$1A,$517E
	fp $07,$1B,$597E
	fp $07,$1C,$41A6
	fp $07,$1D,$49A6
	fp $07,$1F,$59A6
	fp $07,$20,$41CE
	fp $07,$21,$49CE
	fp $07,$30,$426E
	fp $07,$31,$4A6E
	fp $07,$32,$526E
	fp $07,$33,$5A6E
	fp $07,$34,$4296
	fp $07,$35,$4A96
	fp $07,$36,$5296
	fp $07,$37,$5A96
	fp $07,$38,$42BE
	fp $07,$39,$4ABE
	fp $07,$3A,$52BE
	fp $07,$3B,$5ABE
	fp $07,$3C,$42E6
	fp $07,$3D,$4AE6
	fp $07,$3E,$52E6
	fp $07,$3F,$5AE6
	;
	; ---
	;
ntsc_1
	fp $08,$02,$508F
	fp $08,$03,$588F
	fp $08,$04,$40B7
	fp $08,$05,$48B7
	fp $08,$06,$50B7
	fp $08,$07,$58B7
	fp $08,$08,$40DF
	fp $08,$09,$48DF
	fp $08,$0A,$50DF
	fp $08,$0B,$58DF
	fp $08,$0C,$4107
	fp $08,$0D,$4907
	fp $08,$0E,$5107
	fp $08,$0F,$5907
	fp $08,$10,$412F
	fp $08,$11,$492F
	fp $08,$12,$512F
	fp $08,$19,$497F
	fp $08,$1A,$517F
	fp $08,$1B,$597F
	fp $08,$1C,$41A7
	fp $08,$1D,$49A7
	fp $08,$1E,$51A7
	fp $08,$1F,$59A7
	fp $08,$20,$41CF
	fp $08,$21,$49CF
	fp $08,$22,$51CF
	fp $08,$23,$59CF
	fp $08,$24,$41F7
	fp $08,$25,$49F7
	fp $08,$26,$51F7
	fp $08,$27,$59F7
	fp $08,$28,$421F
	fp $08,$30,$426F
	fp $08,$31,$4A6F
	fp $08,$32,$526F
	fp $08,$33,$5A6F
	fp $08,$34,$4297
	fp $08,$35,$4A97
	fp $08,$36,$5297
	fp $08,$37,$5A97
	fp $08,$38,$42BF
	fp $08,$39,$4ABF
	fp $08,$3A,$52BF
	fp $08,$3B,$5ABF
	fp $08,$3C,$42E7
	fp $08,$3D,$4AE7
	fp $08,$3E,$52E7
	fp $08,$3F,$5AE7
	;
	; ---
	;
	fp $09,$02,$5090
	fp $09,$03,$5890
	fp $09,$04,$40B8
	fp $09,$05,$48B8
	fp $09,$06,$50B8
	fp $09,$07,$58B8
	fp $09,$08,$40E0
	fp $09,$09,$48E0
	fp $09,$0A,$50E0
	fp $09,$0B,$58E0
	fp $09,$0C,$4108
	fp $09,$0D,$4908
	fp $09,$0E,$5108
	fp $09,$0F,$5908
	fp $09,$10,$4130
	fp $09,$11,$4930
	fp $09,$12,$5130
	fp $09,$18,$4180
	fp $09,$19,$4980
	fp $09,$1A,$5180
	fp $09,$1B,$5980
	fp $09,$1C,$41A8
	fp $09,$1D,$49A8
	fp $09,$1E,$51A8
	fp $09,$1F,$59A8
	fp $09,$20,$41D0
	fp $09,$21,$49D0
	fp $09,$22,$51D0
	fp $09,$23,$59D0
	fp $09,$24,$41F8
	fp $09,$25,$49F8
	fp $09,$26,$51F8
	fp $09,$27,$59F8
	fp $09,$28,$4220
	;
	; ---
	;
	fp $0A,$02,$5091
	fp $0A,$03,$5891
	fp $0A,$04,$40B9
	fp $0A,$05,$48B9
	fp $0A,$06,$50B9
	fp $0A,$07,$58B9
	fp $0A,$08,$40E1
	fp $0A,$09,$48E1
	fp $0A,$0A,$50E1
	fp $0A,$0B,$58E1
	fp $0A,$0C,$4109
	fp $0A,$0D,$4909
	fp $0A,$0E,$5109
	fp $0A,$0F,$5909
	fp $0A,$10,$4131
	fp $0A,$11,$4931
	fp $0A,$19,$4981
	fp $0A,$1A,$5181
	fp $0A,$1B,$5981
	fp $0A,$1C,$41A9
	fp $0A,$1D,$49A9
	fp $0A,$1E,$51A9
	fp $0A,$1F,$59A9
	fp $0A,$20,$41D1
	fp $0A,$21,$49D1
	fp $0A,$22,$51D1
	fp $0A,$23,$59D1
	fp $0A,$24,$41F9
	fp $0A,$25,$49F9
	fp $0A,$26,$51F9
	fp $0A,$27,$59F9
	fp $0A,$28,$4221
	rts
	
;fli_colors_column
;	;lda #$07			; brightness in lower nibble
;	;sta $5000+3*40+15
;	;lda #$60			; color in upper nibble
;	;sta $5400+3*40+15
;	;
;	;lda #$07
;	;sta $5800+3*40+15
;	;lda #$60
;	;sta $5C00+3*40+15
;	inc fc1+1
;fc1	lda #$07
;	sta $5087
;	sta $5887
;	sta $40AF
;	sta $48AF
;	sta $50AF
;	sta $58AF
;	sta $40D7
;	sta $48D7
;	sta $50D7
;	sta $58D7
;	sta $40FF
;	sta $48FF
;	sta $50FF
;	sta $58FF
;	sta $4127
;	sta $4927
;	sta $5127
;	sta $4177
;	sta $4977
;	sta $5177
;	sta $5977
;	sta $419F
;	sta $499F
;	sta $519F
;	sta $599F
;	sta $41C7
;	sta $49C7
;	sta $51C7
;	sta $59C7
;	sta $41EF
;	sta $49EF
;	sta $51EF
;	sta $59EF
;	sta $4217
;	;
;	clc
;	adc #$01
;	sta $5088
;	sta $5888
;	sta $40B0
;	sta $48B0
;	sta $50B0
;	sta $4900
;	sta $5100
;	sta $5900
;	sta $4128
;	sta $4928
;	sta $5128
;	sta $4178
;	sta $4978
;	sta $5178
;	sta $5978
;	sta $41A0
;	sta $49A0
;	sta $51A0
;	sta $59A0
;	sta $41C8
;	sta $49C8
;	sta $51C8
;	sta $59C8
;	sta $41F0
;	sta $49F0
;	sta $51F0
;	sta $59F0
;	sta $4218
;	sta $4A68
;	sta $5268
;	sta $5A68
;	sta $4AE0
;	sta $52E0
;	sta $5AE0
;	;
;	clc
;	adc #$01
;	sta $5089
;	sta $5889
;	sta $40B1
;	sta $48B1
;	sta $50B1
;	sta $58B1
;	sta $40D9
;	sta $48D9
;	sta $50D9
;	sta $58D9
;	sta $4101
;	sta $4901
;	sta $5101
;	sta $5901
;	sta $4129
;	sta $4929
;	sta $5129
;	sta $4179
;	sta $4979
;	sta $5179
;	sta $5979
;	sta $41A1
;	sta $49A1
;	sta $51A1
;	sta $59A1
;	sta $41C9
;	sta $49C9
;	sta $51C9
;	sta $59C9
;	sta $41F1
;	sta $49F1
;	sta $51F1
;	sta $59F1
;	sta $4219
;	sta $4269
;	sta $4A69
;	sta $5269
;	sta $5A69
;	sta $4291
;	sta $4A91
;	sta $5291
;	sta $5A91
;	sta $42B9
;	sta $4AB9
;	sta $52B9
;	sta $5AB9
;	sta $42E1
;	sta $4AE1
;	sta $52E1
;	sta $5AE1
;	;
;	clc
;	adc #$01
;	sta $508A
;	sta $588A
;	sta $40B2
;	sta $48B2
;	sta $50B2
;	sta $58B2
;	sta $40DA
;	sta $48DA
;	sta $50DA
;	sta $58DA
;	sta $4102
;	sta $4902
;	sta $5102
;	sta $5902
;	sta $412A
;	sta $492A
;	sta $512A
;	sta $497A
;	sta $517A
;	sta $597A
;	sta $41A2
;	sta $49A2
;	sta $51A2
;	sta $59A2
;	sta $41CA
;	sta $49CA
;	sta $51CA
;	sta $59CA
;	sta $41F2
;	sta $49F2
;	sta $51F2
;	sta $59F2
;	sta $421A
;	sta $5ABA
;	sta $42E2
;	sta $4AE2
;	sta $52E2
;	sta $5AE2
;	;
;	clc
;	adc #$01
;	sta $4103
;	sta $4903
;	sta $5103
;	sta $5903
;	sta $412B
;	sta $492B
;	sta $512B
;	sta $497B
;	sta $517B
;	sta $597B
;	sta $41A3
;	sta $49A3
;	sta $51A3
;	sta $59A3
;	sta $41CB
;	sta $49CB
;	sta $51CB
;	sta $59CB
;	sta $41F3
;	sta $49F3
;	sta $51F3
;	sta $59F3
;	sta $421B
;	sta $426B
;	sta $4A6B
;	sta $526B
;	sta $5A6B
;	sta $4293
;	sta $4A93
;	sta $5293
;	sta $5A93
;	sta $42BB
;	sta $5ABB
;	sta $42E3
;	sta $4AE3
;	sta $52E3
;	sta $5AE3
;	;
;	clc
;	adc #$01
;	sta $508C
;	sta $588C
;	sta $40B4
;	sta $48B4
;	sta $50B4
;	sta $58B4
;	sta $40DC
;	sta $48DC
;	sta $50DC
;	sta $58DC
;	sta $4104
;	sta $4904
;	sta $5104
;	sta $5904
;	sta $412C
;	sta $492C
;	sta $512C
;	sta $497C
;	sta $517C
;	sta $597C
;	sta $41A4
;	sta $49A4
;	sta $51A4
;	sta $59A4
;	sta $41CC
;	sta $49CC
;	sta $51CC
;	sta $59CC
;	sta $41F4
;	sta $49F4
;	sta $51F4
;	sta $59F4
;	sta $421C
;	sta $426C
;	sta $4A6C
;	sta $526C
;	sta $5A6C
;	sta $4A94
;	sta $5294
;	sta $5A94
;	sta $42BC
;	sta $4ABC
;	sta $52BC
;	sta $5ABC
;	sta $42E4
;	sta $4AE4
;	sta $52E4
;	sta $5AE4
;	;
;	clc
;	adc #$01
;	sta $508D
;	sta $588D
;	sta $40B5
;	sta $48B5
;	sta $50B5
;	sta $58B5
;	sta $40DD
;	sta $48DD
;	sta $50DD
;	sta $58DD
;	sta $4105
;	sta $4905
;	sta $5105
;	sta $5905
;	sta $412D
;	sta $492D
;	sta $512D
;	sta $417D
;	sta $497D
;	sta $517D
;	sta $597D
;	sta $41A5
;	sta $49A5
;	sta $51A5
;	sta $59A5
;	sta $41CD
;	sta $49CD
;	sta $51CD
;	sta $59CD
;	sta $41F5
;	sta $49F5
;	sta $51F5
;	sta $59F5
;	sta $421D
;	sta $426D
;	sta $4A6D
;	sta $526D
;	sta $5A6D
;	sta $4295
;	sta $4A95
;	sta $5295
;	sta $5A95
;	sta $42BD
;	sta $4ABD
;	sta $52BD
;	sta $5ABD
;	sta $42E5
;	sta $4AE5
;	sta $52E5
;	sta $5AE5
;	;
;	clc
;	adc #$01
;	sta $508E
;	sta $588E
;	sta $40B6
;	sta $48B6
;	sta $50B6
;	sta $58B6
;	sta $40DE
;	sta $48DE
;	sta $50DE
;	sta $58DE
;	sta $4106
;	sta $4906
;	sta $5106
;	sta $5906
;	sta $412E
;	sta $492E
;	sta $512E
;	sta $417E
;	sta $497E
;	sta $517E
;	sta $597E
;	sta $41A6
;	sta $49A6
;	sta $59A6
;	sta $41CE
;	sta $49CE
;	sta $426E
;	sta $4A6E
;	sta $526E
;	sta $5A6E
;	sta $4296
;	sta $4A96
;	sta $5296
;	sta $5A96
;	sta $42BE
;	sta $4ABE
;	sta $52BE
;	sta $5ABE
;	sta $42E6
;	sta $4AE6
;	sta $52E6
;	sta $5AE6
;	;
;	clc
;	adc #$01
;	sta $508F
;	sta $588F
;	sta $40B7
;	sta $48B7
;	sta $50B7
;	sta $58B7
;	sta $40DF
;	sta $48DF
;	sta $50DF
;	sta $58DF
;	sta $4107
;	sta $4907
;	sta $5107
;	sta $5907
;	sta $412F
;	sta $492F
;	sta $512F
;	sta $497F
;	sta $517F
;	sta $597F
;	sta $41A7
;	sta $49A7
;	sta $51A7
;	sta $59A7
;	sta $41CF
;	sta $49CF
;	sta $51CF
;	sta $59CF
;	sta $41F7
;	sta $49F7
;	sta $51F7
;	sta $59F7
;	sta $421F
;	sta $426F
;	sta $4A6F
;	sta $526F
;	sta $5A6F
;	sta $4297
;	sta $4A97
;	sta $5297
;	sta $5A97
;	sta $42BF
;	sta $4ABF
;	sta $52BF
;	sta $5ABF
;	sta $42E7
;	sta $4AE7
;	sta $52E7
;	sta $5AE7
;	;
;	clc
;	adc #$01
;	sta $5090
;	sta $5890
;	sta $40B8
;	sta $48B8
;	sta $50B8
;	sta $58B8
;	sta $40E0
;	sta $48E0
;	sta $50E0
;	sta $58E0
;	sta $4108
;	sta $4908
;	sta $5108
;	sta $5908
;	sta $4130
;	sta $4930
;	sta $5130
;	sta $4180
;	sta $4980
;	sta $5180
;	sta $5980
;	sta $41A8
;	sta $49A8
;	sta $51A8
;	sta $59A8
;	sta $41D0
;	sta $49D0
;	sta $51D0
;	sta $59D0
;	sta $41F8
;	sta $49F8
;	sta $51F8
;	sta $59F8
;	sta $4220
;	;
;	clc
;	adc #$01
;	sta $5091
;	sta $5891
;	sta $40B9
;	sta $48B9
;	sta $50B9
;	sta $58B9
;	sta $40E1
;	sta $48E1
;	sta $50E1
;	sta $58E1
;	sta $4109
;	sta $4909
;	sta $5109
;	sta $5909
;	sta $4131
;	sta $4931
;	sta $4981
;	sta $5181
;	sta $5981
;	sta $41A9
;	sta $49A9
;	sta $51A9
;	sta $59A9
;	sta $41D1
;	sta $49D1
;	sta $51D1
;	sta $59D1
;	sta $41F9
;	sta $49F9
;	sta $51F9
;	sta $59F9
;	sta $4221
;	rts

flash_letters
flc	lda #$00			; delay
	clc
	adc #$01
	and #$03
	sta flc+1
	bne fl3
	;
	lda fl4+1
	clc
	adc #$01
	cmp #$08
	bne *+4
	lda #$00
	sta fl4+1
	;
	lda fl5+1
	sec
	sbc #$01
	cmp #$FF
	bne *+4
	lda #$07
	sta fl5+1
	;
fl3	lda $FFFF
	bne fl31
	lda digi_addr+2
	cmp #hhat
	bcs fl31
	;
	inc fl32+1
fl32	lda #$00
	and #$01
	beq *+5
	ldx #$81
	db $2C
	ldx #$11
	stx letter_colors+0
	stx letter_colors+1
	stx letter_colors+2
	stx letter_colors+3
	;
	cmp #$01
	beq *+5
	ldx #$91
	db $2C
	ldx #$11
	stx letter_colors+4
	stx letter_colors+5
	stx letter_colors+6
	stx letter_colors+7
	;
	cmp #$00
	beq *+5
	ldx #$41
	db $2C
	ldx #$11
	stx letter_colors+8
	stx letter_colors+9
	stx letter_colors+10
	;
	jmp color_all_letters
	;
fl31	;
fl4	ldx #$00
	lda letter_lum,x
	ora #$80
	sta letter_colors+0
	;
	lda letter_lum+1,x
	ora #$80
	sta letter_colors+1
	;
	lda letter_lum+2,x
	ora #$80
	sta letter_colors+2
	;
	lda letter_lum+3,x
	ora #$80
	sta letter_colors+3
	;
	; ---
	;
	lda letter_lum,x
	ora #$40
	sta letter_colors+8
	;
	lda letter_lum+1,x
	ora #$40
	sta letter_colors+9
	;
	lda letter_lum+2,x
	ora #$40
	sta letter_colors+10
	;
	; ---
	;
fl5	ldx #$04
	lda letter_lum,x
	ora #$90
	sta letter_colors+4
	;
	lda letter_lum+1,x
	ora #$90
	sta letter_colors+5
	;
	lda letter_lum+2,x
	ora #$90
	sta letter_colors+6
	;
	lda letter_lum+3,x
	ora #$90
	sta letter_colors+7
	;
	jmp color_all_letters
	
flash_data_reset_2
	lda #flash_data_2 & 255
	sta flash_data_reset+1
	lda #flash_data_2 >> 8
	sta flash_data_reset+5
	rts
	
flash_data_reset
	lda #flash_data & 255
	sta flash_data_ptr
	lda #flash_data >> 8
	sta flash_data_ptr+1
	rts
	
flash_words_reset
	jsr flash_data_reset
	;
flash_words
	ldy #$00
fw5	lda (flash_data_ptr),y		; starting index
	iny
	cmp #$FF
	beq fw1
	cmp #$FE
	beq flash_words_reset
	sta fw2+1
	;
	lda (flash_data_ptr),y		; end index
	iny
	sta fw3+1
	;
	lda (flash_data_ptr),y		; color
	iny
	;
fw2	ldx #$00			; once those 3 values are set (start, end, color)
fw4	sta letter_colors,x		; perform the coloring
	inx
fw3	cpx #$00
	bne fw4
	;
	beq fw5				; keep going
	;
fw1	tya
	clc
	adc flash_data_ptr
	sta flash_data_ptr
	bcc *+4
	inc flash_data_ptr+1 
	;
	jmp color_all_letters
	
color_all_letters
	ldx #$00
cal0	jsr color_one_letter
	inx
	cpx #11
	bne cal0
	rts

	;
	; X = letter index
	;
color_one_letter
	lda letter_colors,x
	tay
	and #$0F
	sta fl_lum+1
	;
	tya
	and #$F0
	sta fl_col+1
	;
	lda letter_pos_lo,x
	sta temp_ptr
	lda letter_pos_hi,x
	sta temp_ptr+1
	;
	ldy #$00
fl2	lda (temp_ptr),y
	sta fl_ptr1+1
	sta fl_ptr2+1 
	iny
	lda (temp_ptr),y
	bmi fl1
	sta fl_ptr1+2
	ora #$04
	sta fl_ptr2+2
	iny
	;
fl_lum	lda #$01
fl_ptr1	sta $FFFF
fl_col	lda #$90
fl_ptr2	sta $FFFF
	;
	bne fl2
	;
fl1	rts

letter_lum
	db 3,4,5,6,7,6,5,4
	db 3,4,5,6,7,6,5,4
	db 3,4,5,6,7,6,5,4

letter_colors
	db $93,$94,$95,$96
	db $86,$85,$84,$83
	db $43,$44,$45

letter_pos_lo
	db letter_c_pos & 255
	db letter_l_pos & 255
	db letter_u_pos & 255
	db letter_b_pos & 255
	;
	db letter_i_pos & 255
	db letter_n_pos & 255
	db letter_f_pos & 255
	db letter_o_pos & 255
	;
	db letter_1_pos & 255
	db letter_5_pos & 255
	db letter_0_pos & 255
	
letter_pos_hi
	db letter_c_pos >> 8
	db letter_l_pos >> 8
	db letter_u_pos >> 8
	db letter_b_pos >> 8
	;
	db letter_i_pos >> 8
	db letter_n_pos >> 8
	db letter_f_pos >> 8
	db letter_o_pos >> 8
	;
	db letter_1_pos >> 8
	db letter_5_pos >> 8
	db letter_0_pos >> 8
	
letter_c_pos
	dw $4087
	dw $4088
	dw $4087+40
	dw $4088+40
	dw $4087+80
	dw $4087+120
	dw $4088+120
	dw $4087+160
	dw $4088+160
	dw $FFFF
	
letter_l_pos
	dw $4089
	dw $408A
	dw $4089+40
	dw $408A+40
	dw $4089+80
	dw $408A+80
	dw $4089+120
	dw $408A+120
	dw $408B+120
	dw $4089+160
	dw $408A+160
	dw $408B+160
	dw $FFFF
	
letter_u_pos
	dw $408C
	dw $408D
	dw $408E
	dw $408C+40
	dw $408D+40
	dw $408E+40
	dw $408C+80
	dw $408D+80
	dw $408E+80
	dw $408C+120
	dw $408D+120
	dw $408E+120
	dw $408C+160
	dw $408D+160
	dw $408E+160
	dw $FFFF
	
letter_b_pos
	dw $408F
	dw $4090
	dw $4091
	dw $408F+40
	dw $4090+40
	dw $4091+40
	dw $408F+80
	dw $4090+80
	dw $4091+80
	dw $408F+120
	dw $4090+120
	dw $4091+120
	dw $408F+160
	dw $4090+160
	dw $4091+160
	dw $FFFF
	
letter_i_pos
	dw $4177
	dw $4178
	dw $4177+40
	dw $4178+40
	dw $4177+80
	dw $4178+80
	dw $4177+120
	dw $4178+120
	dw $4177+160
	dw $4178+160
	dw $FFFF
	
letter_n_pos
	dw $4179
	dw $417A
	dw $417B
	dw $4179+40
	dw $417A+40
	dw $417B+40
	dw $4179+80
	dw $417A+80
	dw $417B+80
	dw $4179+120
	dw $417A+120
	dw $417B+120
	dw $4179+160
	dw $417A+160
	dw $417B+160
	dw $FFFF
	
letter_f_pos
	dw $417C
	dw $417D
	dw $417E
	dw $417C+40
	dw $417D+40
	dw $417E+40
	dw $417C+80
	dw $417D+80
	dw $417E+80
	dw $417C+120
	dw $417D+120
	dw $417C+160
	dw $417D+160
	dw $FFFF
	
letter_o_pos
	dw $417F
	dw $4180
	dw $4181
	dw $417F+40
	dw $4180+40
	dw $4181+40
	dw $417F+80
	dw $4180+80
	dw $4181+80
	dw $417F+120
	dw $4180+120
	dw $4181+120
	dw $417F+160
	dw $4180+160
	dw $4181+160
	dw $FFFF
	
letter_1_pos
	dw $4268
	dw $4269
	dw $4269+40
	dw $4269+80
	dw $4268+120
	dw $4269+120
	dw $FFFF
	
letter_5_pos
	dw $426B
	dw $426C
	dw $426B+40
	dw $426C+40
	dw $426A+80
	dw $426B+80
	dw $426C+80
	dw $426A+120
	dw $426B+120
	dw $426C+120
	dw $FFFF
	
letter_0_pos
	dw $426D
	dw $426E
	dw $426F
	dw $426D+40
	dw $426E+40
	dw $426F+40
	dw $426D+80
	dw $426E+80
	dw $426F+80
	dw $426D+120
	dw $426E+120
	dw $426F+120
	dw $FFFF
	
flash_data
	db 0,11,$87,$FF,$FF
	db 0,11,$86,$FF,$FF
	db 0,11,$85,$FF,$FF
	db 0,11,$84,$FF,$FF
	db 0,11,$83,$FF,$FF
	db 0,11,$82,$FF,$FF
	;
	db 0,11,$97,$FF,$FF
	db 0,11,$96,$FF,$FF
	db 0,11,$95,$FF,$FF
	db 0,11,$94,$FF,$FF
	db 0,11,$93,$FF,$FF
	db 0,11,$92,$FF,$FF
	;
	db 0,4,$46,4,11,$16,$FF
	db 0,4,$45,$FF
	db 0,4,$44,$FF
	db 0,4,$43,$FF
	db 0,4,$42,$FF
	db 0,4,$41,$FF
	;
	db 4,8,$46,0,4,$16,$FF
	db 4,8,$45,$FF
	db 4,8,$44,$FF
	db 4,8,$43,$FF
	db 4,8,$42,$FF
	db 4,8,$41,$FF
	;
	db 8,11,$46,4,8,$16,$FF
	db 8,11,$45,$FF
	db 8,11,$44,$FF
	db 8,11,$43,$FF
	db 8,11,$42,$FF
	db 8,11,$41,$FF
	;
	db 0,11,$87,$FF,$FF
	db 0,11,$86,$FF,$FF
	db 0,11,$85,$FF,$FF
	db 0,11,$84,$FF,$FF
	db 0,11,$83,$FF,$FF
	db 0,11,$82,$FF,$FF
	;
	db 0,11,$97,$FF
	db 0,11,$96,$FF
	db 0,11,$95,$FF
	db 0,11,$94,$FF
	db 0,11,$93,$FF
	db 0,11,$92,$FF
	;
	db 0,2,$16,$FF,$FF,$FF,$FF,$FF,$FF
	db 2,4,$16,$FF,$FF,$FF,$FF,$FF,$FF
	db 4,6,$16,$FF,$FF,$FF,$FF,$FF,$FF
	db 6,8,$16,$FF,$FF,$FF,$FF,$FF,$FF
	db 8,9,$16,$FF,$FF,$FF,$FF,$FF,$FF
	db 9,11,$16,$FF,$FF,$FF,$FF,$FF,$FF
	;
	db 0,11,$97,$FF,$FF
	db 0,11,$96,$FF,$FF
	db 0,11,$95,$FF,$FF
	db 0,11,$94,$FF,$FF
	db 0,11,$93,$FF,$FF
	db 0,11,$92,$FF,$FF
	;
	db 0,11,$87,$FF,$FF
	db 0,11,$86,$FF,$FF
	db 0,11,$85,$FF,$FF
	db 0,11,$84,$FF,$FF
	db 0,11,$83,$FF,$FF
	db 0,11,$82,$FF,$FF
	;
	db 8,11,$46,0,8,$16,$FF
	db 8,11,$45,$FF
	db 8,11,$44,$FF
	db 8,11,$43,$FF
	db 8,11,$42,$FF
	db 8,11,$41,$FF
	;
	db 4,8,$46,8,11,$16,$FF
	db 4,8,$45,$FF
	db 4,8,$44,$FF
	db 4,8,$43,$FF
	db 4,8,$42,$FF
	db 4,8,$41,$FF
	;
	db 0,4,$46,4,8,$16,$FF
	db 0,4,$45,$FF
	db 0,4,$44,$FF
	db 0,4,$43,$FF
	db 0,4,$42,$FF
	db 0,4,$41,$FF
	;
	db 0,11,$87,$FF,$FF
	db 0,11,$86,$FF,$FF
	db 0,11,$85,$FF,$FF
	db 0,11,$84,$FF,$FF
	db 0,11,$83,$FF,$FF
	db 0,11,$82,$FF,$FF
	;
	db 0,11,$16,$FF,$FF,$FF,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF
	;
	db $FF,$FF,$FF,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF
	;
	db $FE
	
flash_data_2
	db 0,11,$17,$FF
	db 0,11,$87,$FF,$FF,$FF
	db 0,11,$86,$FF,$FF
	db 0,11,$26,$FF,$FF
	db 0,11,$25,$FF,$FF
	db 0,11,$B5,$FF,$FF
	db 0,11,$B4,$FF,$FF,$FF,$FF
	db 0,11,$B3,$FF,$FF
	db 0,11,$43,$FF,$FF
	db 0,11,$42,$FF,$FF,$FF,$FF
	db 0,11,$41,$FF,$FF,$FF,$FF
	db 0,11,$40,$FF,$FF,$FF,$FF
	;
	db 0,11,$40,$FF,$FF,$FF,$FF
	db 0,11,$41,$FF,$FF,$FF,$FF
	db 0,11,$42,$FF,$FF,$FF,$FF
	db 0,11,$43,$FF,$FF
	db 0,11,$B3,$FF,$FF
	db 0,11,$B4,$FF,$FF,$FF,$FF
	db 0,11,$B5,$FF,$FF
	db 0,11,$25,$FF,$FF
	db 0,11,$26,$FF,$FF
	db 0,11,$86,$FF,$FF
	db 0,11,$87,$FF,$FF,$FF
	db 0,11,$17,$FF
	;
	db $FE
	
	include "timeline.asm"
	
timeline
;	dw 1,set_colors_intro_text_done
;	;dw 1,set_colors_4
;	dw 11,copy_next_letter
;	dw 1,bg_to_71
;	dw 1,irq2_to_9D
;	dw 1,fli_on
;	dw 1,set_colors_rainbow
;	dw $FFFF,move_fli_colors_center
;	dw $FFFF,fli_plasma
;	dw 150,move_fli_colors
;	dw 150,fli_plasma
;	dw 150,move_fli_colors
;	dw 150,fli_plasma
;	dw 150,move_fli_colors
;	dw 150,fli_plasma
;	dw 150,move_fli_colors
;	dw 150,fli_plasma
;	dw 150,move_fli_colors
	
	dw 1,copy_intro_text
	dw 95, nothing
	dw 1,copy_intro_text
	dw 95, nothing
	dw 1,copy_intro_text
	dw 95, nothing
	dw 1,copy_intro_text
	dw 95, nothing
	dw 1,copy_intro_text
	dw 95, nothing
	dw 1,copy_intro_text
	dw 95, nothing
	dw 1,copy_intro_text
	dw 95, nothing
	dw 1,copy_intro_text
	dw 87, nothing
	dw 8,erase_intro_text

	dw 1,set_colors_intro_text_done
	dw 1,set_colors_1
	dw 134,nothing
	dw 24,sprite_all	; 1+1+134+24 = 160
	
	dw 1,copy_next_letter
	dw 1,bg_to_51
	dw 1,bg_to_61
	dw 1,bg_to_71
	dw 132,nothing
	dw 24,sprite_all	; 1+1+134+24 = 160
	
	dw 1,copy_next_letter
	dw 1,bg_to_51
	dw 1,bg_to_61
	dw 1,bg_to_71
	dw 132,nothing
	dw 24,sprite_all	; 1+1+134+24 = 160
	
	dw 1,copy_next_letter
	dw 1,bg_to_51
	dw 1,bg_to_61
	dw 1,bg_to_71
	dw 52,nothing
	dw 24,sprite_all	; 1+1+54+24 = 80
	
	dw 1,copy_next_letter
	dw 1,bg_to_51
	dw 1,bg_to_61
	dw 1,bg_to_71
	dw 52,nothing
	dw 24,sprite_all	; 1+1+54+24 = 80
	
	dw 1,copy_next_letter
	dw 1,bg_to_51
	dw 1,bg_to_61
	dw 1,bg_to_71
	dw 132,nothing
	dw 24,sprite_all	; 1+1+134+24 = 160
	
	dw 1,copy_next_letter
	dw 1,bg_to_51
	dw 1,bg_to_61
	dw 1,bg_to_71
	dw 132,nothing
	dw 24,sprite_all	; 1+1+134+24 = 160
	
	dw 1,copy_next_letter
	dw 1,bg_to_51
	dw 1,bg_to_61
	dw 1,bg_to_71
	dw 52,nothing
	dw 24,sprite_all	; 1+1+54+24 = 80
	
	dw 1,copy_next_letter
	dw 1,bg_to_51
	dw 1,bg_to_61
	dw 1,bg_to_71
	dw 52,nothing
	dw 24,sprite_all	; 1+1+54+24 = 80
	
	dw 1,copy_next_letter
	dw 1,bg_to_51
	dw 1,bg_to_61
	dw 1,bg_to_71
	dw 52,nothing
	dw 24,sprite_all	; 1+1+54+24 = 80
	
	dw 1,copy_next_letter
	dw 1,bg_to_51
	dw 1,bg_to_61
	dw 1,bg_to_71
	dw 52,nothing
	dw 24,sprite_all	; 1+1+54+24 = 80
	
	dw 1,copy_next_letter
	dw 1,bg_to_51
	dw 1,bg_to_61
	dw 1,bg_to_71
	
	dw 1,star_start
	dw 158,nothing
	dw 1,irq2_to_9D
	;
	dw 192,flash_words
	dw 192,flash_words
	dw 192,flash_words
	dw 192,flash_words
	dw 192,flash_words
	dw 192,flash_words
	
	dw 1,set_colors_9
	dw 1,fli_on
	dw 192-2,move_fli_colors
	dw 1,set_colors_4
	dw 191,move_fli_colors_diag
	dw 1,set_colors_8
	dw 191,move_fli_colors_diag_sine
	dw 1,set_colors_B
	dw 191,move_fli_colors_center
	
	dw 1,set_colors_rainbow
	dw 191,move_fli_colors_center
	dw 192,fli_plasma
	dw 1,set_colors_4
	dw 191,move_fli_colors_diag_sine
	dw 191,fli_plasma
	dw 1,fli_off
	;
	dw 192,flash_words
	dw 192,flash_words
	dw 192,flash_words
	dw 192,flash_words
	dw 192,flash_words
	dw 192,flash_words
	;
	; --- digi start
	;
	dw 4*8*10,flash_letters
	dw 4*8*10,flash_letters
	dw 4*8*10,flash_letters
	dw 4*8*10,flash_letters
	dw 4*8*10,flash_letters
	dw 4*8*10,flash_letters
	;
	dw 4*8*10,flash_letters
	dw 4*8*10,flash_letters
	dw 4*8*10,flash_letters
	dw 4*8*10,flash_letters
	dw 4*8*10,flash_letters
	;
	dw 8*4,copy_credits
	dw 1,flash_data_reset_2
	dw 96*8,flash_words
	dw 96*8,flash_words
	dw 1,the_end

	align 256
sprite_saved
	ds 3*3*8
	
sprite_pos_data
	include "trajectory\data_hex.asm"
	
	align 32
sprite_mask_lo
	db sprite1_mask_1 & 255 ; $00
	db sprite1_mask_2 & 255
	db sprite1_mask_3 & 255
	db sprite1_mask_4 & 255
	;
	db sprite2_mask_1 & 255 ; $04
	db sprite2_mask_2 & 255
	db sprite2_mask_3 & 255
	db sprite2_mask_4 & 255
	;
	db sprite3_mask_1 & 255 ; $08
	db sprite3_mask_2 & 255
	db sprite3_mask_3 & 255
	db sprite3_mask_4 & 255
	;
	db sprite4_mask_1 & 255 ; $0C
	db sprite4_mask_2 & 255
	db sprite4_mask_3 & 255
	db sprite4_mask_4 & 255
	;
	db sprite5_mask_1 & 255 ; $10
	db sprite5_mask_2 & 255
	db sprite5_mask_3 & 255
	db sprite5_mask_4 & 255
	;
	db sprite6_mask_1 & 255 ; $14
	db sprite6_mask_2 & 255
	db sprite6_mask_3 & 255
	db sprite6_mask_4 & 255
sprite_mask_hi
	db sprite1_mask_1 >> 8
	db sprite1_mask_2 >> 8
	db sprite1_mask_3 >> 8
	db sprite1_mask_4 >> 8
	;
	db sprite2_mask_1 >> 8
	db sprite2_mask_2 >> 8
	db sprite2_mask_3 >> 8
	db sprite2_mask_4 >> 8
	;
	db sprite3_mask_1 >> 8
	db sprite3_mask_2 >> 8
	db sprite3_mask_3 >> 8
	db sprite3_mask_4 >> 8
	;
	db sprite4_mask_1 >> 8
	db sprite4_mask_2 >> 8
	db sprite4_mask_3 >> 8
	db sprite4_mask_4 >> 8
	;
	db sprite5_mask_1 >> 8
	db sprite5_mask_2 >> 8
	db sprite5_mask_3 >> 8
	db sprite5_mask_4 >> 8
	;
	db sprite6_mask_1 >> 8
	db sprite6_mask_2 >> 8
	db sprite6_mask_3 >> 8
	db sprite6_mask_4 >> 8
sprite_gfx_lo
	db sprite1_gfx_1 & 255
	db sprite1_gfx_2 & 255
	db sprite1_gfx_3 & 255
	db sprite1_gfx_4 & 255
	;
	db sprite2_gfx_1 & 255
	db sprite2_gfx_2 & 255
	db sprite2_gfx_3 & 255
	db sprite2_gfx_4 & 255
	;
	db sprite3_gfx_1 & 255
	db sprite3_gfx_2 & 255
	db sprite3_gfx_3 & 255
	db sprite3_gfx_4 & 255
	;
	db sprite4_gfx_1 & 255
	db sprite4_gfx_2 & 255
	db sprite4_gfx_3 & 255
	db sprite4_gfx_4 & 255
	;
	db sprite5_gfx_1 & 255
	db sprite5_gfx_2 & 255
	db sprite5_gfx_3 & 255
	db sprite5_gfx_4 & 255
	;
	db sprite6_gfx_1 & 255
	db sprite6_gfx_2 & 255
	db sprite6_gfx_3 & 255
	db sprite6_gfx_4 & 255
sprite_gfx_hi
	db sprite1_gfx_1 >> 8
	db sprite1_gfx_2 >> 8
	db sprite1_gfx_3 >> 8
	db sprite1_gfx_4 >> 8
	;         
	db sprite2_gfx_1 >> 8
	db sprite2_gfx_2 >> 8
	db sprite2_gfx_3 >> 8
	db sprite2_gfx_4 >> 8
	;
	db sprite3_gfx_1 >> 8
	db sprite3_gfx_2 >> 8
	db sprite3_gfx_3 >> 8
	db sprite3_gfx_4 >> 8
	;
	db sprite4_gfx_1 >> 8
	db sprite4_gfx_2 >> 8
	db sprite4_gfx_3 >> 8
	db sprite4_gfx_4 >> 8
	;
	db sprite5_gfx_1 >> 8
	db sprite5_gfx_2 >> 8
	db sprite5_gfx_3 >> 8
	db sprite5_gfx_4 >> 8
	;
	db sprite6_gfx_1 >> 8
	db sprite6_gfx_2 >> 8
	db sprite6_gfx_3 >> 8
	db sprite6_gfx_4 >> 8
	
	align 256
sprite1_mask_1	; 24*24 m none charset
	db $FC,$F0,$C0,$C0,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$C0,$C0,$F0
	db $FC,$FF,$FF,$FF,$FF,$FF,$FF,$FF

	db $0F,$03,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$03
	db $0F,$FF,$FF,$FF,$FF,$FF,$FF,$FF

	db $FF,$FF,$FF,$FF,$3F,$3F,$3F,$3F
	db $3F,$3F,$3F,$3F,$3F,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
sprite1_gfx_1	; 24*24 m none charset
	db $00,$03,$0F,$0F,$3F,$3F,$3F,$3F
	db $3F,$3F,$3F,$3F,$3F,$0F,$0F,$03
	db $00,$00,$00,$00,$00,$00,$00,$00

	db $00,$F0,$FC,$FC,$FF,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FC,$FC,$F0
	db $00,$00,$00,$00,$00,$00,$00,$00

	db $00,$00,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00
sprite1_mask_2	; 24*24 m none charset
	db $FF,$FC,$F0,$F0,$C0,$C0,$C0,$C0
	db $C0,$C0,$C0,$C0,$C0,$F0,$F0,$FC
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF

	db $03,$00,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00
	db $03,$FF,$FF,$FF,$FF,$FF,$FF,$FF

	db $FF,$FF,$3F,$3F,$0F,$0F,$0F,$0F
	db $0F,$0F,$0F,$0F,$0F,$3F,$3F,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
sprite1_gfx_2	; 24*24 m none charset
	db $00,$00,$03,$03,$0F,$0F,$0F,$0F
	db $0F,$0F,$0F,$0F,$0F,$03,$03,$00
	db $00,$00,$00,$00,$00,$00,$00,$00

	db $00,$FC,$FF,$FF,$FF,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FC
	db $00,$00,$00,$00,$00,$00,$00,$00

	db $00,$00,$00,$00,$C0,$C0,$C0,$C0
	db $C0,$C0,$C0,$C0,$C0,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00
sprite1_mask_3	; 24*24 m none charset
	db $FF,$FF,$FC,$FC,$F0,$F0,$F0,$F0
	db $F0,$F0,$F0,$F0,$F0,$FC,$FC,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF

	db $C0,$00,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00
	db $C0,$FF,$FF,$FF,$FF,$FF,$FF,$FF

	db $FF,$3F,$0F,$0F,$03,$03,$03,$03
	db $03,$03,$03,$03,$03,$0F,$0F,$3F
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
sprite1_gfx_3	; 24*24 m none charset
	db $00,$00,$00,$00,$03,$03,$03,$03
	db $03,$03,$03,$03,$03,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00

	db $00,$3F,$FF,$FF,$FF,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$3F
	db $00,$00,$00,$00,$00,$00,$00,$00

	db $00,$00,$C0,$C0,$F0,$F0,$F0,$F0
	db $F0,$F0,$F0,$F0,$F0,$C0,$C0,$00
	db $00,$00,$00,$00,$00,$00,$00,$00
sprite1_mask_4	; 24*24 m none charset
	db $FF,$FF,$FF,$FF,$FC,$FC,$FC,$FC
	db $FC,$FC,$FC,$FC,$FC,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF

	db $F0,$C0,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$C0
	db $F0,$FF,$FF,$FF,$FF,$FF,$FF,$FF

	db $3F,$0F,$03,$03,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$03,$03,$0F
	db $3F,$FF,$FF,$FF,$FF,$FF,$FF,$FF
sprite1_gfx_4	; 24*24 m none charset
	db $00,$00,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00

	db $00,$0F,$3F,$3F,$FF,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$3F,$3F,$0F
	db $00,$00,$00,$00,$00,$00,$00,$00

	db $00,$C0,$F0,$F0,$FC,$FC,$FC,$FC
	db $FC,$FC,$FC,$FC,$FC,$F0,$F0,$C0
	db $00,$00,$00,$00,$00,$00,$00,$00
	
sprite2_mask_1	; 24*24 m none charset
	db $FF,$FC,$F0,$C0,$C0,$C0,$00,$00
	db $00,$00,$00,$C0,$C0,$C0,$F0,$FC
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF

	db $FF,$0F,$03,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$03,$0F
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF

	db $FF,$FF,$FF,$FF,$FF,$FF,$3F,$3F
	db $3F,$3F,$3F,$FF,$FF,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
sprite2_gfx_1	; 24*24 m none charset
	db $00,$00,$03,$0F,$0F,$0F,$3F,$3F
	db $3F,$3F,$3F,$0F,$0F,$0F,$03,$00
	db $00,$00,$00,$00,$00,$00,$00,$00

	db $00,$00,$F0,$FC,$FC,$FC,$FF,$FF
	db $FF,$FF,$FF,$FC,$FC,$FC,$F0,$00
	db $00,$00,$00,$00,$00,$00,$00,$00

	db $00,$00,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00
sprite2_mask_2	; 24*24 m none charset
	db $FF,$FF,$FC,$F0,$F0,$F0,$C0,$C0
	db $C0,$C0,$C0,$F0,$F0,$F0,$FC,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF

	db $FF,$03,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$03
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF

	db $FF,$FF,$FF,$3F,$3F,$3F,$0F,$0F
	db $0F,$0F,$0F,$3F,$3F,$3F,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
sprite2_gfx_2	; 24*24 m none charset
	db $00,$00,$00,$03,$03,$03,$0F,$0F
	db $0F,$0F,$0F,$03,$03,$03,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00

	db $00,$00,$FC,$FF,$FF,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FC,$00
	db $00,$00,$00,$00,$00,$00,$00,$00

	db $00,$00,$00,$00,$00,$00,$C0,$C0
	db $C0,$C0,$C0,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00
sprite2_mask_3	; 24*24 m none charset
	db $FF,$FF,$FF,$FC,$FC,$FC,$F0,$F0
	db $F0,$F0,$F0,$FC,$FC,$FC,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF

	db $FF,$C0,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$C0
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF

	db $FF,$FF,$3F,$0F,$0F,$0F,$03,$03
	db $03,$03,$03,$0F,$0F,$0F,$3F,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
sprite2_gfx_3	; 24*24 m none charset
	db $00,$00,$00,$00,$00,$00,$03,$03
	db $03,$03,$03,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00

	db $00,$00,$3F,$FF,$FF,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$3F,$00
	db $00,$00,$00,$00,$00,$00,$00,$00

	db $00,$00,$00,$C0,$C0,$C0,$F0,$F0
	db $F0,$F0,$F0,$C0,$C0,$C0,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00
sprite2_mask_4	; 24*24 m none charset
	db $FF,$FF,$FF,$FF,$FF,$FF,$FC,$FC
	db $FC,$FC,$FC,$FF,$FF,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF

	db $FF,$F0,$C0,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$C0,$F0
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF

	db $FF,$3F,$0F,$03,$03,$03,$00,$00
	db $00,$00,$00,$03,$03,$03,$0F,$3F
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
sprite2_gfx_4	; 24*24 m none charset
	db $00,$00,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00

	db $00,$00,$0F,$3F,$3F,$3F,$FF,$FF
	db $FF,$FF,$FF,$3F,$3F,$3F,$0F,$00
	db $00,$00,$00,$00,$00,$00,$00,$00

	db $00,$00,$C0,$F0,$F0,$F0,$FC,$FC
	db $FC,$FC,$FC,$F0,$F0,$F0,$C0,$00
	db $00,$00,$00,$00,$00,$00,$00,$00
	
sprite3_mask_1	; 24*24 m none charset
	db $FF,$FF,$FC,$F0,$F0,$C0,$C0,$C0
	db $C0,$C0,$C0,$C0,$F0,$F0,$FC,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF

	db $FF,$FF,$0F,$03,$03,$00,$00,$00
	db $00,$00,$00,$00,$03,$03,$0F,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF

	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
sprite3_gfx_1	; 24*24 m none charset
	db $00,$00,$00,$03,$03,$0F,$0F,$0F
	db $0F,$0F,$0F,$0F,$03,$03,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00

	db $00,$00,$00,$F0,$F0,$FC,$FC,$FC
	db $FC,$FC,$FC,$FC,$F0,$F0,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00

	db $00,$00,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00
sprite3_mask_2	; 24*24 m none charset
	db $FF,$FF,$FF,$FC,$FC,$F0,$F0,$F0
	db $F0,$F0,$F0,$F0,$FC,$FC,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF

	db $FF,$FF,$03,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$03,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF

	db $FF,$FF,$FF,$FF,$FF,$3F,$3F,$3F
	db $3F,$3F,$3F,$3F,$FF,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
sprite3_gfx_2	; 24*24 m none charset
	db $00,$00,$00,$00,$00,$03,$03,$03
	db $03,$03,$03,$03,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00

	db $00,$00,$00,$FC,$FC,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FC,$FC,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00

	db $00,$00,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00
sprite3_mask_3	; 24*24 m none charset
	db $FF,$FF,$FF,$FF,$FF,$FC,$FC,$FC
	db $FC,$FC,$FC,$FC,$FF,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF

	db $FF,$FF,$C0,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$C0,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF

	db $FF,$FF,$FF,$3F,$3F,$0F,$0F,$0F
	db $0F,$0F,$0F,$0F,$3F,$3F,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
sprite3_gfx_3	; 24*24 m none charset
	db $00,$00,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00

	db $00,$00,$00,$3F,$3F,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$3F,$3F,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00

	db $00,$00,$00,$00,$00,$C0,$C0,$C0
	db $C0,$C0,$C0,$C0,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00
sprite3_mask_4	; 24*24 m none charset
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF

	db $FF,$FF,$F0,$C0,$C0,$00,$00,$00
	db $00,$00,$00,$00,$C0,$C0,$F0,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF

	db $FF,$FF,$3F,$0F,$0F,$03,$03,$03
	db $03,$03,$03,$03,$0F,$0F,$3F,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
sprite3_gfx_4	; 24*24 m none charset
	db $00,$00,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00

	db $00,$00,$00,$0F,$0F,$3F,$3F,$3F
	db $3F,$3F,$3F,$3F,$0F,$0F,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00

	db $00,$00,$00,$C0,$C0,$F0,$F0,$F0
	db $F0,$F0,$F0,$F0,$C0,$C0,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00

sprite4_mask_1	; 24*24 m none charset
	db $FF,$FF,$FF,$FC,$FC,$F0,$F0,$F0
	db $F0,$F0,$F0,$F0,$FC,$FC,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF

	db $FF,$FF,$FF,$0F,$0F,$03,$03,$03
	db $03,$03,$03,$03,$0F,$0F,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF

	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
sprite4_gfx_1	; 24*24 m none charset
	db $00,$00,$00,$00,$00,$00,$03,$03
	db $03,$03,$03,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00

	db $00,$00,$00,$00,$00,$C0,$F0,$F0
	db $F0,$F0,$F0,$C0,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00

	db $00,$00,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00
sprite4_mask_2	; 24*24 m none charset
	db $FF,$FF,$FF,$FF,$FF,$FC,$FC,$FC
	db $FC,$FC,$FC,$FC,$FF,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF

	db $FF,$FF,$FF,$03,$03,$00,$00,$00
	db $00,$00,$00,$00,$03,$03,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF

	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
sprite4_gfx_2	; 24*24 m none charset
	db $00,$00,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00

	db $00,$00,$00,$00,$00,$30,$FC,$FC
	db $FC,$FC,$FC,$30,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00

	db $00,$00,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00
sprite4_mask_3	; 24*24 m none charset
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF

	db $FF,$FF,$FF,$C0,$C0,$00,$00,$00
	db $00,$00,$00,$00,$C0,$C0,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF

	db $FF,$FF,$FF,$FF,$FF,$3F,$3F,$3F
	db $3F,$3F,$3F,$3F,$FF,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
sprite4_gfx_3	; 24*24 m none charset
	db $00,$00,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00

	db $00,$00,$00,$00,$00,$0C,$3F,$3F
	db $3F,$3F,$3F,$0C,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00

	db $00,$00,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00
sprite4_mask_4	; 24*24 m none charset
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF

	db $FF,$FF,$FF,$F0,$F0,$C0,$C0,$C0
	db $C0,$C0,$C0,$C0,$F0,$F0,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF

	db $FF,$FF,$FF,$3F,$3F,$0F,$0F,$0F
	db $0F,$0F,$0F,$0F,$3F,$3F,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
sprite4_gfx_4	; 24*24 m none charset
	db $00,$00,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00

	db $00,$00,$00,$00,$00,$03,$0F,$0F
	db $0F,$0F,$0F,$03,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00

	db $00,$00,$00,$00,$00,$00,$C0,$C0
	db $C0,$C0,$C0,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00
	
sprite5_mask_1	; 24*24 m none charset
	db $FF,$FF,$FF,$FF,$FF,$FF,$FC,$FC
	db $FC,$FC,$FC,$FF,$FF,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF

	db $FF,$FF,$FF,$FF,$FF,$3F,$0F,$0F
	db $0F,$0F,$0F,$3F,$FF,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF

	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
sprite5_gfx_1	; 24*24 m none charset
	db $00,$00,$00,$00,$00,$00,$00,$03
	db $03,$03,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00

	db $00,$00,$00,$00,$00,$00,$C0,$F0
	db $F0,$F0,$C0,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00

	db $00,$00,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00
sprite5_mask_2	; 24*24 m none charset
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF

	db $FF,$FF,$FF,$FF,$FF,$CF,$03,$03
	db $03,$03,$03,$CF,$FF,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF

	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
sprite5_gfx_2	; 24*24 m none charset
	db $00,$00,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00

	db $00,$00,$00,$00,$00,$00,$30,$FC
	db $FC,$FC,$30,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00

	db $00,$00,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00
sprite5_mask_3	; 24*24 m none charset
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF

	db $FF,$FF,$FF,$FF,$FF,$F3,$C0,$C0
	db $C0,$C0,$C0,$F3,$FF,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF

	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
sprite5_gfx_3	; 24*24 m none charset
	db $00,$00,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00

	db $00,$00,$00,$00,$00,$00,$0C,$3F
	db $3F,$3F,$0C,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00

	db $00,$00,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00
sprite5_mask_4	; 24*24 m none charset
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF

	db $FF,$FF,$FF,$FF,$FF,$FC,$F0,$F0
	db $F0,$F0,$F0,$FC,$FF,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF

	db $FF,$FF,$FF,$FF,$FF,$FF,$3F,$3F
	db $3F,$3F,$3F,$FF,$FF,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
sprite5_gfx_4	; 24*24 m none charset
	db $00,$00,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00

	db $00,$00,$00,$00,$00,$00,$03,$0F
	db $0F,$0F,$03,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00

	db $00,$00,$00,$00,$00,$00,$00,$C0
	db $C0,$C0,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00

sprite6_mask_1	; 24*24 m none charset
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FC
	db $FC,$FC,$FF,$FF,$FF,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF

	db $FF,$FF,$FF,$FF,$FF,$FF,$3F,$0F
	db $0F,$0F,$3F,$FF,$FF,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF

	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
sprite6_gfx_1	; 24*24 m none charset
	db $00,$00,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00

	db $00,$00,$00,$00,$00,$00,$00,$C0
	db $C0,$C0,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00

	db $00,$00,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00
sprite6_mask_2	; 24*24 m none charset
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF

	db $FF,$FF,$FF,$FF,$FF,$FF,$CF,$03
	db $03,$03,$CF,$FF,$FF,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF

	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
sprite6_gfx_2	; 24*24 m none charset
	db $00,$00,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00

	db $00,$00,$00,$00,$00,$00,$00,$30
	db $30,$30,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00

	db $00,$00,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00
sprite6_mask_3	; 24*24 m none charset
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF

	db $FF,$FF,$FF,$FF,$FF,$FF,$F3,$C0
	db $C0,$C0,$F3,$FF,$FF,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF

	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
sprite6_gfx_3	; 24*24 m none charset
	db $00,$00,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00

	db $00,$00,$00,$00,$00,$00,$00,$0C
	db $0C,$0C,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00

	db $00,$00,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00
sprite6_mask_4	; 24*24 m none charset
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF

	db $FF,$FF,$FF,$FF,$FF,$FF,$FC,$F0
	db $F0,$F0,$FC,$FF,$FF,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF

	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$3F
	db $3F,$3F,$FF,$FF,$FF,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
sprite6_gfx_4	; 24*24 m none charset
	db $00,$00,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00

	db $00,$00,$00,$00,$00,$00,$00,$03
	db $03,$03,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00

	db $00,$00,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$00,$00,$00
	
	align 256
star	; 16*104 m none
	db $FF,$FF,$FF,$FC,$FF,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF

	db $FF,$FF,$FC,$FC,$FC,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF

	db $FF,$FF,$FC,$F0,$FC,$FF,$FF,$FF
	db $FF,$FF,$FF,$3F,$FF,$FF,$FF,$FF

	db $FF,$FC,$FC,$F0,$FC,$FC,$FF,$FF
	db $FF,$FF,$FF,$3F,$FF,$FF,$FF,$FF

	db $FF,$FC,$FC,$C0,$FC,$FC,$FF,$FF
	db $FF,$FF,$FF,$0F,$FF,$FF,$FF,$FF

	db $FC,$FC,$FC,$C0,$FC,$FC,$FC,$FF
	db $FF,$FF,$FF,$0F,$FF,$FF,$FF,$FF

	db $FC,$FC,$F0,$00,$F0,$FC,$FC,$FF
	db $FF,$FF,$3F,$03,$3F,$FF,$FF,$FF

	db $FC,$FC,$FC,$C0,$FC,$FC,$FC,$FF
	db $FF,$FF,$FF,$0F,$FF,$FF,$FF,$FF

	db $FF,$FC,$FC,$C0,$FC,$FC,$FF,$FF
	db $FF,$FF,$FF,$0F,$FF,$FF,$FF,$FF

	db $FF,$FC,$FC,$F0,$FC,$FC,$FF,$FF
	db $FF,$FF,$FF,$3F,$FF,$FF,$FF,$FF

	db $FF,$FF,$FC,$F0,$FC,$FF,$FF,$FF
	db $FF,$FF,$FF,$3F,$FF,$FF,$FF,$FF

	db $FF,$FF,$FC,$FC,$FC,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF

	db $FF,$FF,$FF,$FC,$FF,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
	
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
	db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
	
star_saved
	ds 16
	
credits_lo
	db credits1 & 255
	db credits2 & 255
	db credits3 & 255
	db credits4 & 255
	
credits_hi
	db credits1 >> 8
	db credits2 >> 8
	db credits3 >> 8
	db credits4 >> 8
	
credits_dst_lo
	db ($2000+21*320) & 255
	db ($2000+22*320) & 255
	db ($2000+23*320) & 255
	db ($2000+24*320) & 255
	
credits_dst_hi
	db ($2000+21*320) >> 8
	db ($2000+22*320) >> 8
	db ($2000+23*320) >> 8
	db ($2000+24*320) >> 8
	
credits_len
	db 17-8
	db 17-6
	db 17
	db 17
	
	; 136*32 m none
credits1
	db $AA,$AA,$AA,$AA,$AA,$AA,$80,$8F
	db $99,$66,$99,$A6,$A9,$A6,$00,$FC
	db $44,$51,$54,$55,$94,$65,$00,$FC
	db $00,$00,$40,$00,$40,$10,$00,$FC
	db $00,$00,$00,$00,$00,$00,$00,$00
	db $00,$00,$00,$00,$00,$FC,$C0,$C0
	db $00,$00,$00,$00,$00,$03,$00,$F3
	db $00,$00,$00,$00,$00,$00,$00,$3F
	db $00,$00,$00,$00,$00,$30,$30,$3F
;	db $01,$03,$00,$00,$00,$00,$00,$00
;	db $B5,$F5,$2D,$0B,$02,$00,$00,$00
;	db $66,$55,$55,$95,$D5,$BF,$33,$00
;	db $5A,$5A,$66,$59,$55,$FF,$F8,$01
;	db $55,$57,$9D,$6D,$F4,$80,$01,$00
;	db $C0,$40,$00,$03,$1D,$B7,$BF,$0C
;	db $0F,$3F,$F5,$69,$AE,$79,$44,$50
;	db $FF,$5F,$B7,$01,$00,$00,$02,$00

credits2
	db $8C,$8C,$8C,$8C,$80,$AA,$80,$8F
	db $CC,$CC,$CC,$CC,$00,$8F,$0C,$FF
	db $0C,$FC,$CC,$FC,$00,$24,$00,$33
	db $CC,$CC,$CC,$FC,$0C,$FC,$00,$01
	db $C0,$00,$C0,$00,$00,$3F,$30,$31
	db $F0,$C0,$C0,$FC,$00,$30,$30,$3F
	db $C3,$C3,$C3,$C3,$00,$00,$00,$3C
	db $30,$30,$30,$3F,$00,$00,$00,$FC
	db $33,$33,$33,$33,$00,$00,$00,$FC
	db $00,$00,$00,$00,$00,$00,$00,$FC
	db $00,$00,$01,$04,$01,$04,$00,$FC
;	db $0A,$52,$04,$40,$00,$00,$00,$00
;	db $14,$55,$44,$00,$80,$01,$0A,$22
;	db $50,$04,$11,$44,$40,$00,$80,$00
;	db $01,$45,$54,$40,$10,$40,$00,$00
;	db $40,$10,$00,$00,$00,$00,$00,$00
;	db $00,$01,$00,$00,$00,$00,$00,$00

credits3
	db $8C,$8C,$8C,$8F,$80,$8F,$80,$8F
	db $CC,$CC,$CC,$CC,$C0,$CA,$00,$CF
	db $33,$0C,$33,$33,$00,$A8,$00,$CF
	db $30,$01,$31,$01,$05,$C5,$C0,$CF
	db $30,$31,$30,$3F,$00,$55,$05,$C5
	db $33,$33,$33,$33,$00,$55,$40,$4F
	db $30,$30,$30,$30,$00,$11,$00,$FC
	db $CC,$CC,$CC,$FC,$00,$11,$00,$CC
	db $CC,$CC,$CC,$CC,$00,$00,$00,$FC
	db $CC,$CC,$CC,$FC,$00,$C0,$00,$CF
	db $C0,$FC,$0C,$FC,$00,$11,$04,$C1
	db $00,$00,$00,$00,$00,$0F,$0C,$0C
	db $04,$10,$00,$00,$00,$C0,$00,$0F
	db $00,$00,$00,$00,$00,$00,$00,$CF
	db $00,$00,$00,$00,$00,$0C,$0C,$CF
	db $00,$00,$00,$00,$06,$29,$00,$CF
	db $01,$05,$15,$65,$95,$55,$09,$C6

credits4
	db $8C,$8C,$8C,$8F,$80,$AA,$AA,$AA
	db $0C,$8C,$0C,$CF,$00,$AA,$AA,$AA
	db $CC,$CC,$CC,$CF,$00,$AA,$AA,$AA
	db $CC,$CF,$CC,$CF,$00,$A6,$99,$A6
	db $C9,$C6,$00,$CC,$0C,$80,$AA,$AA
	db $8C,$4C,$8C,$8C,$80,$A6,$AA,$AA
	db $CC,$CC,$CC,$CC,$00,$66,$99,$A6
	db $CC,$CC,$CC,$FC,$00,$66,$A9,$AA
	db $C0,$FC,$0C,$FC,$00,$66,$9A,$A6
	db $CC,$CC,$CC,$CF,$00,$66,$99,$6A
	db $0C,$40,$0C,$C0,$09,$66,$99,$66
	db $4C,$0C,$4C,$4F,$40,$55,$94,$55
	db $0C,$0F,$00,$CF,$00,$10,$40,$10
	db $00,$CF,$CC,$CF,$00,$00,$00,$00
	db $CC,$CC,$CC,$CF,$00,$00,$00,$00
	db $CC,$CC,$CC,$CF,$00,$00,$00,$00
	db $C5,$C5,$C5,$C5,$0D,$0E,$00,$00
	
	align 256
	include "letters.asm"
	
	align 32
letter_src_lo
	db ltr_c & 255
	db ltr_l & 255
	db ltr_u & 255
	db ltr_b & 255
	;
	db ltr_i & 255
	db ltr_n & 255
	db ltr_f & 255
	db ltr_o & 255
	;
	db ltr_1 & 255
	db ltr_5 & 255
	db ltr_0 & 255
	
letter_src_hi
	db ltr_c >> 8
	db ltr_l >> 8
	db ltr_u >> 8
	db ltr_b >> 8
	;
	db ltr_i >> 8
	db ltr_n >> 8
	db ltr_f >> 8
	db ltr_o >> 8
	;
	db ltr_1 >> 8
	db ltr_5 >> 8
	db ltr_0 >> 8
	
letter_dst_lo
	db $22E8 & 255
	db $2308 & 255
	db $2318 & 255
	db $2330 & 255
	;
	db $2A70 & 255
	db $2A80 & 255
	db $2AA0 & 255
	db $2AB0 & 255
	;
	db $31F8 & 255
	db $3210 & 255
	db $3228 & 255
	
letter_dst_hi
	db $22E8 >> 8
	db $2308 >> 8
	db $2318 >> 8
	db $2330 >> 8
	;
	db $2A70 >> 8
	db $2A80 >> 8
	db $2AA0 >> 8
	db $2AB0 >> 8
	;
	db $31F8 >> 8
	db $3210 >> 8
	db $3228 >> 8
	
	align 256
intro_text
	include "intro_text.asm"
	
intro_text_ptr_data
	db 0,8				; line #1: In 1991
	dw intro_text+0*96
	dw $2570+0*320
	;
	db 0,2
	dw intro_text+1*96
	dw $2570+1*320
	;
	db $FF
	;
	db 6,8				; line #2
	dw intro_text+1*96
	dw $2570+1*320
	;
	db 0,7
	dw intro_text+2*96
	dw $2570+2*320
	;
	db $FF
	;
	db 4,8				; line #3
	dw intro_text+3*96
	dw $2570+3*320
	;
	db 0,6
	dw intro_text+4*96
	dw $2570+4*320
	;
	db $FF
	;
	db 2,8				; line #4
	dw intro_text+5*96
	dw $2570+5*320
	;
	db 0,4
	dw intro_text+6*96
	dw $2570+6*320
	;
	db $FF
	;
	db 0,8				; line #5
	dw intro_text+7*96
	dw $2570+7*320
	;
	db 0,4
	dw intro_text+8*96
	dw $2570+8*320
	;
	db $FF
	;
	db 6,8				; line #6
	dw intro_text+8*96
	dw $2570+8*320
	;
	db 0,8
	dw intro_text+9*96
	dw $2570+9*320
	;
	db 0,2
	dw intro_text+10*96
	dw $2570+10*320
	;
	db $FF
	;
	db 4,8				; line #7
	dw intro_text+10*96
	dw $2570+10*320
	;
	db 0,5
	dw intro_text+11*96
	dw $2570+11*320
	;
	db $FF
	;
	db 2,8				; line #8
	dw intro_text+12*96
	dw $2570+12*320
	;
	db 0,5
	dw intro_text+13*96
	dw $2570+13*320
	;
	db $FF
	
	include "music/!player.asm"
	include "music/music.asm"
	
	align 256
raster_colors
	db 0,1,2,3,4,5,6,7, 7,6,5,4,3,2,1,0
	db 0,1,2,3,4,5,6,7, 7,6,5,4,3,2,1,0
	db 0,1,2,3,4,5,6,7, 7,6,5,4,3,2,1,0
	db 0,1,2,3,4,5,6,7, 7,6,5,4,3,2,1,0
	;
	db 0,1,2,3,4,5,6,7, 7,6,5,4,3,2,1,0
	db 0,1,2,3,4,5,6,7, 7,6,5,4,3,2,1,0
	db 0,1,2,3,4,5,6,7, 7,6,5,4,3,2,1,0
	db 0,1,2,3,4,5,6,7, 7,6,5,4,3,2,1,0
	;
	db 0,1,2,3,4,5,6,7, 7,6,5,4,3,2,1,0
	db 0,1,2,3,4,5,6,7, 7,6,5,4,3,2,1,0
	db 0,1,2,3,4,5,6,7, 7,6,5,4,3,2,1,0
	db 0,1,2,3,4,5,6,7, 7,6,5,4,3,2,1,0
	
	align 256
colors
	db $00
;eof